'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽ法）
Imports System.Drawing

Public Class Diff3DCal4
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(120, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(256, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "拡散計算の実行（バンドマトリックス法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(136, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(224, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'Diff3DCal4
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Diff3DCal4"
        Me.Text = "Diff3DCal4"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim Nbound As Integer           '濃度固定の全節点数

    Dim Fw1, Fw2 As Single          '進行表示の水平枠位置

    Dim KConcRange(2) As Integer    '最低・最高濃度の節点番号 
    Dim Nrest() As Integer          '濃度固定の全節点番号

    Dim CE(20) As Double            '要素節点の濃度
    Dim CG(27) As Double            'ｶﾞｳｽ点の濃度
    Dim ConcFix(,) As Double        '全固定濃度
    Dim ConcRange(2) As Single      '最低・最高濃度
    Dim Ek(20, 20) As Double        '要素計算の２次配列
    Dim Fc(), Em(20, 20) As Double  '非定常計算の追加配列
    Dim Qq(20) As Double            '内部発濃度率の節点への換算量
    Dim Rkc(,), Rmc(,) As Double    '非定常の行列
    Dim Rkr(,), Fr() As Double      '濃度放射用の配列
    Dim TConcRange(2) As Single     '最低・最高濃度の時間
    Dim Tf() As Double              'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tk(,) As Double             'FEM行列の1次元保存配列
    Dim TUx() As Double             '前回の濃度
    Dim Ua() As Double              '解の一次記憶ﾍﾞｸﾄﾙ

    Private Sub BandWidth(ByRef mb As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ie, ii, j, jj, k, mx, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        mx = 0
        For ie = 1 To Nelem
            For ii = 1 To nmax - 1
                i = NNelem(ie, ii)
                For jj = ii + 1 To nmax
                    j = NNelem(ie, jj)
                    'k = Math.Abs(i - j)
                    k = Math.Abs(Kcomp(i) - Kcomp(j))
                    If k > mx Then mx = k
                Next jj
            Next ii
        Next ie
        mb = Ndim * (mx + 1)

    End Sub

    Private Sub Debug1(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽを出力して停止
        Dim aa$, fxx$
        Dim i, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素マトリックスデータ"
        WriteLine(ii, aa$)
        aa$ = "要素" + Str$(ie)
        WriteLine(ii, aa$)
        For i = 1 To 20
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            aa$ = Str$(Ek(i, 1))
            For j = 2 To 10
                aa$ = aa$ + "," + Str$(Ek(i, j))
            Next
            PrintLine(ii, aa$)
            aa$ = Str$(Ek(i, 11))
            For j = 12 To 20
                aa$ = aa$ + "," + Str$(Ek(i, j))
            Next
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2(ByVal mb As Integer)
        'ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽと右辺値を出力して停止
        Dim aa$, fxx$
        Dim i, j, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "バンドマトリックスデータ"
        WriteLine(ii, aa$)
        For i = 1 To Npoint
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            aa$ = Str$(Tk(i, 1))
            For j = 2 To mb
                aa$ = aa$ + "," + Str$(Tk(i, j))
            Next
            PrintLine(ii, aa$)
            WriteLine(ii, "  右辺", Str$(Tf(i)))
        Next i
        FileClose(ii)
        Stop

    End Sub

    Private Sub Debug3()
        '解を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\Th3DCal4debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "解データ"
        WriteLine(ii, aa$)
        For i = 1 To Npoint
            WriteLine(ii, i, Str$(Tu(i)))
        Next i
        FileClose(ii)
        Stop

    End Sub

    Private Sub DconcCalc(ByRef dconcx As Double)
        '最大濃度変化の計算
        'dconcx･･･最大濃度変化値
        Dim i As Integer
        Dim b1 As Double
        dconcx = 0
        For i = 1 To Nall
            b1 = Math.Abs(Tu(i) - TUx(i))
            If b1 > dconcx Then
                dconcx = b1
            End If
        Next i
    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer)
        '要素マトリックスの計算
        'ie･･･要素番号
        Dim i, id, ig, ii, j, jg, k, kg, kmat, nmax, numg As Integer
        Dim b1, concb, diffb, dj, dv, s, t, u As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            CE(ii) = Tu(Kcomp(i))
        Next ii
        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
                If Mstat > 0 Then
                    Em(i, j) = 0
                End If
            Next j
        Next i
        kmat = NumMat(ie)

        If KindElem = 0 Then
            numg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    For kg = 1 To Ngaus
                        numg = numg + 1
                        u = PosGaus(kg)
                        Call ShapeFunc(1, s, t, u)         '形状関数の計算
                        Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                        dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                        concb = CG(numg)
                        Call StateCalc(kmat, concb, diffb)   '物性状態の計算
                        For i = 1 To Nvar
                            For j = i To Nvar
                                b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                Ek(i, j) = Ek(i, j) + diffb * b1 * dv
                                If Mstat > 0 Then
                                    Em(i, j) = Em(i, j) + Shape(i) * Shape(j) * dv
                                End If
                            Next j
                        Next i
                    Next kg
                Next jg
            Next ig
        End If

        j = 0
        For ii = 1 To nmax
            i = NNelem(ie, ii)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1 : k = k + 1
                NPrefer(j) = k
            Next id
        Next ii

    End Sub

    Private Sub HeatFluxSet(ByVal istep As Integer)
        '濃度流束の節点への換算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ii, j, jj, k1, k2, kb, kgp1, kgp2 As Integer
        Dim kind, kk, nmax, numg As Integer
        Dim b1, da, dj, pnb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Nflux
            ie = KsurfFlux(ii, 1)
            kb = KsurfFlux(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
            End If
            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j

            pnb = Pnorm(ii, istep)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select
                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(j) = Tf(j) - pnb * Shape(kk) * da
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub HeatTrans(ByVal istep As Integer)
        '濃度伝達の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim i, ib, ie, ii, it, itb, j, jj, jt, k1, k2 As Integer
        Dim kgp1, kgp2, kind, kk, kk1, kk2, kx, nmax, numg As Integer
        Dim alpb, b1, b2, b3, concb, da, dj As Double
        Dim kbuf(8) As Integer
        Dim gpos(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For ii = 1 To Namb
            ie = KsurfAmb(ii, 1)
            kx = KsurfAmb(ii, 2)
            If KindElem = 0 Then
                Call SurfaceCond(kx, kind, kbuf, gpos)  '境界条件用の面設定
            End If
            For j = 1 To nmax
                ib = NNelem(ie, j)
                XE(j) = Xdata(ib)
                YE(j) = Ydata(ib)
                ZE(j) = Zdata(ib)
            Next j

            alpb = Alpha(ii, istep)
            concb = ConcAmb(ii, istep)
            If KindElem = 0 Then
                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select

                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        b1 = alpb * da
                        b2 = b1 * concb
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelem(ie, kk))
                            Tf(j) = Tf(j) + b2 * Shape(kk)
                        Next i
                        For i = 1 To 8
                            kk1 = kbuf(i)
                            ib = Kcomp(NNelem(ie, kk1))
                            For j = i To 8
                                it = ib
                                kk2 = kbuf(j)
                                jt = Kcomp(NNelem(ie, kk2))
                                If it > jt Then
                                    itb = it
                                    it = jt
                                    jt = itb
                                End If
                                b3 = b1 * Shape(kk1) * Shape(kk2)
                                Tk(it, jt - it + 1) = Tk(it, jt - it + 1) + b3
                            Next j
                        Next i
                    Next k2
                Next k1
            End If
        Next ii

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ie, j, jj, jmax, k, kb As Integer

        If KindElem = 0 Then
            jmax = 8
            Nvar = 20
        End If
        Nall = Ndim * Npoint
        ReDim NPrefer(Nvar)
        ReDim Tf(Nall), Tu(Nall)

        '濃度固定ﾃﾞｰﾀの処理
        Nbound = NboundP
        If NboundS > 0 Then
            Nbound = Nbound + jmax * NboundS
        End If
        If Nbound > 0 Then
            ReDim Nrest(Nbound), ConcFix(Nbound, Nstep)
            k = 0
            If NboundP > 0 Then
                For i = 1 To NboundP
                    k = k + 1
                    Nrest(k) = NrestP(i)
                    For j = 1 To Nstep
                        ConcFix(k, j) = ConcFixP(i, j)
                    Next j
                Next i
            End If
            If NboundS > 0 Then
                Dim kbuf(8) As Integer
                For i = 1 To NboundS
                    ie = KsurfRest(i, 1)
                    kb = KsurfRest(i, 2)
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    End If
                    For j = 1 To jmax
                        k = k + 1
                        Nrest(k) = kbuf(j)
                        For jj = 1 To Nstep
                            ConcFix(k, jj) = ConcFixS(i, jj)
                        Next jj
                    Next j
                Next i
            End If
        End If

        If InitData > 0 Then
            For i = 1 To Npoint
                Tu(Kcomp(i)) = ConcInit(i)
            Next i
        End If

        If Mstat > 0 Then
            ReDim Fc(Nall), TUx(Nall)
            For i = 1 To Nall
                TUx(i) = Tu(i)
            Next i
        End If

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub JacobElem(ByVal ie As Integer, ByVal numg As Integer, _
        ByRef dj As Double)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'numg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        Dim c1$, c2$
        Dim i, ii, j, nmax As Integer
        Dim b1 As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To 3
            For j = 1 To 3
                RinvJ(i, j) = 0
                RJmat(i, j) = 0
            Next j
        Next i
        CG(numg) = 0
        For ii = 1 To nmax
            CG(numg) = CG(numg) + CE(ii) * Shape(ii)
            For j = 1 To 3
                Select Case j
                    Case 1
                        b1 = XE(ii)
                    Case 2
                        b1 = YE(ii)
                    Case 3
                        b1 = ZE(ii)
                End Select
                RJmat(1, j) = RJmat(1, j) + Ds(ii) * b1
                RJmat(2, j) = RJmat(2, j) + Dt(ii) * b1
                RJmat(3, j) = RJmat(3, j) + Du(ii) * b1
            Next j
        Next ii
        RinvJ(1, 1) = RJmat(2, 2) * RJmat(3, 3) - RJmat(2, 3) * RJmat(3, 2)
        RinvJ(1, 2) = RJmat(1, 3) * RJmat(3, 2) - RJmat(1, 2) * RJmat(3, 3)
        RinvJ(1, 3) = RJmat(1, 2) * RJmat(2, 3) - RJmat(1, 3) * RJmat(2, 2)
        RinvJ(2, 1) = RJmat(2, 3) * RJmat(3, 1) - RJmat(2, 1) * RJmat(3, 3)
        RinvJ(2, 2) = RJmat(1, 1) * RJmat(3, 3) - RJmat(1, 3) * RJmat(3, 1)
        RinvJ(2, 3) = RJmat(1, 3) * RJmat(2, 1) - RJmat(1, 1) * RJmat(2, 3)
        RinvJ(3, 1) = RJmat(2, 1) * RJmat(3, 2) - RJmat(2, 2) * RJmat(3, 1)
        RinvJ(3, 2) = RJmat(1, 2) * RJmat(3, 1) - RJmat(1, 1) * RJmat(3, 2)
        RinvJ(3, 3) = RJmat(1, 1) * RJmat(2, 2) - RJmat(1, 2) * RJmat(2, 1)
        b1 = RJmat(1, 1) * RinvJ(1, 1) + RJmat(1, 2) * RinvJ(2, 1)
        dj = b1 + RJmat(1, 3) * RinvJ(3, 1)
        If dj <= 0 Then
            c1$ = "計算実行エラー"
            c2$ = "要素" + LTrim$(Str$(ie)) + "（ガウス点" + LTrim$(Str$(numg))
            c2$ = c2$ + "）でヤコビアン体積が負か０になりました。"
            MsgBox(c2$, 0, c1$)
            End
        Else
            '    本来の逆ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽは下記のようにdjで割った値である。
            '        For i = 1 To 3
            '            For j = 1 To 3
            '                RinvJ(i, j) = RinvJ(i, j) / dj
            '            Next j
            '        Next i
            For ii = 1 To nmax
                For i = 1 To 3
                    b1 = RinvJ(i, 1) * Ds(ii) + RinvJ(i, 2) * Dt(ii)
                    b1 = (b1 + RinvJ(i, 3) * Du(ii)) / dj
                    Select Case i
                        Case 1
                            Dx(ii) = b1
                        Case 2
                            Dy(ii) = b1
                        Case 3
                            Dz(ii) = b1
                    End Select
                Next i
            Next ii
        End If
    End Sub

    Private Sub JacobElem2(ByVal ie As Integer, ByVal numg As Integer, _
        ByRef dj As Double, ByVal knode() As Integer)
        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'numg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        'knode()･･･節点の順位
        Dim i, ii, ip, j, kmax As Integer
        Dim b1 As Double

        If KindElem = 0 Then
            kmax = 8
        End If
        For i = 1 To 3
            For j = 1 To 3
                RinvJ(i, j) = 0
                RJmat(i, j) = 0
            Next j
        Next i
        '    XG(numg) = 0
        '    YG(numg) = 0
        '    ZG(numg) = 0
        '    For ip = 1 To 8
        '        ii = knode(ip)
        '        XG(numg) = XG(numg) + XE(ii) * Shape(ii)
        '        YG(numg) = YG(numg) + YE(ii) * Shape(ii)
        '        ZG(numg) = ZG(numg) + ZE(ii) * Shape(ii)
        '    Next ip
        For ip = 1 To kmax
            ii = knode(ip)
            For j = 1 To 3
                Select Case j
                    Case 1
                        b1 = XE(ii)
                    Case 2
                        b1 = YE(ii)
                    Case 3
                        b1 = ZE(ii)
                End Select
                RJmat(1, j) = RJmat(1, j) + Ds(ii) * b1
                RJmat(2, j) = RJmat(2, j) + Dt(ii) * b1
                RJmat(3, j) = RJmat(3, j) + Du(ii) * b1
            Next j
        Next ip

        '逆ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの配列に、面積分で使用するための値を保存
        RinvJ(1, 1) = RJmat(2, 2) * RJmat(3, 3) - RJmat(2, 3) * RJmat(3, 2)
        RinvJ(1, 2) = RJmat(1, 3) * RJmat(3, 2) - RJmat(1, 2) * RJmat(3, 3)
        RinvJ(1, 3) = RJmat(1, 2) * RJmat(2, 3) - RJmat(1, 3) * RJmat(2, 2)
        RinvJ(2, 1) = RJmat(2, 3) * RJmat(3, 1) - RJmat(2, 1) * RJmat(3, 3)
        RinvJ(2, 2) = RJmat(1, 1) * RJmat(3, 3) - RJmat(1, 3) * RJmat(3, 1)
        RinvJ(2, 3) = RJmat(1, 3) * RJmat(2, 1) - RJmat(1, 1) * RJmat(2, 3)
        RinvJ(3, 1) = RJmat(2, 1) * RJmat(3, 2) - RJmat(2, 2) * RJmat(3, 1)
        RinvJ(3, 2) = RJmat(1, 2) * RJmat(3, 1) - RJmat(1, 1) * RJmat(3, 2)
        RinvJ(3, 3) = RJmat(1, 1) * RJmat(2, 2) - RJmat(1, 2) * RJmat(2, 1)

    End Sub

    Private Sub MemorySet(ByVal mb As Integer, ByVal nx As Integer)
        'ﾒﾓﾘｰ設定
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$
        Dim b1, freemem, reqmem As Single

        freemem = 1000 * FreeMemoryGet()
        reqmem = 8.0 * mb * nx * 1.05
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "変数の数が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "バンドマトリックス法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(nx, mb)

    End Sub

    Private Sub MiniSort(ByRef nsort() As Integer, ByVal work() As Single)
        'ﾐﾆｿｰﾄ
        '同じ変数値の場合に、元の変数順序を保持させるようにソート
        'nsort()･･･元の変数番号のｿｰﾄ順番号
        'work()･･･ｿｰﾄ変数値
        Dim i, j, k, nb, n1, n2 As Integer
        Dim b1 As Single

        i = 1
        Do
            If work(i) = work(i + 1) Then
                b1 = work(i)
                n1 = i
                For j = i + 1 To Npoint
                    If b1 = work(j) Then
                        n2 = j
                    Else
                        Exit For
                    End If
                Next j
                For j = n1 To n2 - 1
                    For k = j + 1 To n2
                        If nsort(j) > nsort(k) Then
                            nb = nsort(j)
                            nsort(j) = nsort(k)
                            nsort(k) = nb
                        End If
                    Next k
                Next j
                i = n2 + 1
            Else
                i = i + 1
            End If
        Loop While i < Npoint

    End Sub

    Private Sub ReqTime(ByVal rmesh As Single, ByVal rmeshsum As Single, _
        ByVal b1 As Double, ByVal b2 As Single)
        '残りの所要時間の計算
        'rmesh･･･ﾒｯｼｭ番号
        'rmeshsum･･･最大ﾒｯｼｭ番号
        'b1･･･拡散の時間差
        'b2･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b3, b4 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b2 < 0 Then
            b2 = b2 + 86400
        End If
        b3 = rmeshsum - rmesh
        If Nstep = 1 Then
            b3 = TimeMax * b3 / rmeshsum
        End If
        b4 = b2 * b3 / b1
        Call TimConv(tima$, b4)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$, c1$, c2$, c3$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜３次元拡散解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)

        aa$ = "解析種類（0:定常、1:非定常）" + "," + Str(Mstat)
        SwK.WriteLine(aa$)
        If Mstat > 0 Then
            If Nstep = 1 Then
                c1$ = "計算打切り時間"
                c2$ = "出力時間メッシュ数"
                aa$ = c1$ + "," + Str(TimeMax) + "," + c2$ + "," + Str(Ntime)
                SwK.WriteLine(aa$)
            Else
                c1$ = "計算サイクル数"
                c2$ = "出力サイクル間隔"
                c3$ = "境界条件のステップ数"
                aa$ = c1$ + "," + Str(Ncycle) + "," + c2$ + "," + Str(Idcycle)
                SwK.WriteLine(aa$)
                aa$ = c3$ + "," + Str(Nstep)
                SwK.WriteLine(aa$)
            End If
            c1$ = "計算時間間隔の初期値"
            c2$ = "    計算１回の濃度変化許容値"
            aa$ = c1$ + "," + Str(DtimeInit) + "," + c2$ + "," + Str(DconcMax)
            SwK.WriteLine(aa$)
        End If

        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$

        SwK.WriteLine("＊＊＊ 計算結果（バンドマトリックス法） ＊＊＊")
        aa$ = "バンド幅" + "," + Str(mb)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile3(ByVal itime As Integer, ByVal icycle As Integer, _
        ByVal istep As Integer)
        '結果ﾌｧｲﾙへの出力3
        'itime･･･時間ﾒｯｼｭ番号
        'icycle･･･ｻｲｸﾙ番号
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim aa$
        Dim ic, ii, ip As Integer
        Dim b1 As Single

        If Mstat > 0 Then
            If Nstep = 1 Then
                aa$ = "＜時間メッシュ番号、時間＞" + ","
                aa$ = aa$ + Str(itime) + "," + Str(TimeNew)
            Else
                aa$ = "＜サイクル番号、ステップ番号、時間＞" + ","
                aa$ = aa$ + Str(icycle) + "," + Str(istep) + "," + Str(TimeNew)
            End If
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("＜節点番号、濃度＞")

        ic = 0
        If Mstat = 0 Or TimeNew = 0 Then
            ic = 1
        End If

        For ip = 1 To Npoint
            ii = Kcomp(ip)
            b1 = Tu(ii)
            aa$ = Str$(ip) + ",  " + Str$(b1)
            SwK.WriteLine(aa$)
            If ic > 0 Then
                KConcRange(1) = 1
                KConcRange(2) = 1
                ConcRange(1) = b1
                ConcRange(2) = b1
                TConcRange(1) = 0
                TConcRange(2) = 0
                ic = 0
            ElseIf b1 < ConcRange(1) Then
                KConcRange(1) = ip
                ConcRange(1) = b1
                TConcRange(1) = TimeNew
            ElseIf b1 > ConcRange(2) Then
                KConcRange(2) = ip
                ConcRange(2) = b1
                TConcRange(2) = TimeNew
            End If
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        If Mstat = 0 Then
            aa$ = "変数項目、    値、            節点番号"
        Else
            aa$ = "変数項目、    値、            節点番号、   時間"
        End If
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最低・最高濃度データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最低・最高濃度データ＞" + Cr$ + aa$
        For i = 1 To 2
            Select Case i
                Case 1
                    aa$ = "濃度Min"
                Case 2
                    aa$ = "濃度Max"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(ConcRange(i)) + ",  "
            If Mstat = 0 Then
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KConcRange(i))
            Else
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KConcRange(i)) + ",  "
                aa$ = aa$ + Space$(44 - Len(aa$)) + Str$(TConcRange(i))
            End If
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it + 1
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(it, j) * ub
                End If
                Tk(it, j) = 0
            Next it
        End If
        If k < Nall Then
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                If ub <> 0 Then
                    it = k + j - 1
                    Tf(it) = Tf(it) - Tk(k, j) * ub
                End If
                Tk(k, j) = 0
            Next j
        End If
        Tk(k, 1) = 1
        Tf(k) = ub

    End Sub

    Private Sub ShellSort(ByVal kind As Integer)
        'ｼｪﾙｿｰﾄ
        Dim i, ib, j, m As Integer
        Dim varb As Single
        Dim nsort(Npoint) As Integer
        Dim work(Npoint) As Single

        Select Case kind
            Case 1
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Xdata(i)
                Next i
            Case 2
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Ydata(i)
                Next i
            Case 3
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Zdata(i)
                Next i
        End Select

        m = Npoint
        Do While m > 1
            m = m \ 2
            For j = m + 1 To Npoint
                varb = work(j)
                ib = nsort(j)
                i = j - m
                Do While work(i) >= varb
                    work(i + m) = work(i)
                    nsort(i + m) = nsort(i)
                    i = i - m
                    If i <= 0 Then
                        Exit Do
                    End If
                Loop
                work(i + m) = varb
                nsort(i + m) = ib
            Next j
        Loop

        Call MiniSort(nsort, work)    'ﾐﾆｿｰﾄ

        For i = 1 To Npoint
            Kcomp(nsort(i)) = i
        Next i

    End Sub

    Private Sub Solver1(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, it, jt, j, k, mx As Integer
        Dim b1 As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        Application.DoEvents()
        icount = 0
        For k = 1 To Nall - 1
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            b1 = Tk(k, 1)
            For j = 2 To mx
                Ua(j) = Tk(k, j) / b1
            Next j
            Tf(k) = Tf(k) / b1
            For i = 2 To mx
                b1 = Tk(k, i)
                If b1 <> 0 Then
                    it = i + k - 1
                    For j = i To mx
                        If Ua(j) <> 0 Then
                            jt = j - i + 1
                            Tk(it, jt) = Tk(it, jt) - b1 * Ua(j)
                        End If
                    Next j
                    Tf(it) = Tf(it) - b1 * Tf(k)
                End If
            Next i
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next k

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mb As Integer)
        'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim j, jt, k, mx As Integer
        Dim s As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)
        For k = Nall - 1 To 1 Step -1
            s = 0 : mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + Tk(k, j) * Tu(jt)
            Next j
            Tu(k) = Tf(k) - s / Tk(k, 1)
        Next k

        gr.Dispose()

    End Sub

    Private Sub StateCalc(ByVal kmat As Integer, ByVal concmesh As Double, ByRef diffmesh As Double)
        '物性状態の計算
        'kmat･･･材料番号
        'concmesh･･･現在濃度
        'diffmesh･･･現在拡散係数
        Dim i As Integer
        Dim b1, b2 As Double
        If NMdiv(kmat) = 0 Then
            diffmesh = DiffMat(kmat, 0)
        Else
            If concmesh < ConcMat(kmat, 0) Then
                diffmesh = ConcMat(kmat, 0)
            ElseIf concmesh > ConcMat(kmat, NMdiv(kmat)) Then
                diffmesh = ConcMat(kmat, NMdiv(kmat))
            Else
                For i = 1 To NMdiv(kmat)
                    If concmesh <= ConcMat(kmat, i) Then
                        b1 = concmesh - ConcMat(kmat, i - 1)
                        b2 = ConcMat(kmat, i) - concmesh
                        diffmesh = (b1 * DiffMat(kmat, i) + b2 * DiffMat(kmat, i - 1)) / (b1 + b2)
                        Exit For
                    End If
                Next i
            End If
        End If
    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, ib, it, j, jt As Integer
        For i = 1 To Nvar
            For j = i To Nvar
                it = NPrefer(i) : jt = NPrefer(j)
                If it > jt Then
                    ib = it
                    it = jt
                    jt = ib
                End If
                If Mstat = 0 Then
                    Tk(it, jt - it + 1) = Tk(it, jt - it + 1) + Ek(i, j)
                Else
                    Rkc(it, jt - it + 1) = Rkc(it, jt - it + 1) + Ek(i, j)
                    Rmc(it, jt - it + 1) = Rmc(it, jt - it + 1) + Em(i, j)
                End If
            Next j
        Next i

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub Diff3DCal4_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, ib, icc, icheck, icount, icycle, ie, ii, istep, itime, ix As Integer
        Dim j, j1, j2, k, kb, kxcycle, mb, mbx, mx, newstep As Integer
        Dim df, drmesh, freemem, fw0, fwx As Single
        Dim rmesh, rmeshsum, sec As Single
        Dim date0, date1, date2 As Date
        Dim b1, dconcx, dtime0, dtime1, dtimestd As Double
        Dim time0, time1, time2, timenext, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定

        Call BandWidth(mb)  'ﾊﾞﾝﾄﾞ幅の計算

        ReDim Ua(mb)
        Call MemorySet(mb, Nall)   'ﾒﾓﾘｰ設定

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2

        If Mstat > 0 Then
            If Nstep = 1 Then
                df = (Fw2 - Fw1) / Ntime
                rmeshsum = Ntime     'ﾒｯｼｭ合計
            Else
                b1 = 0
                For i = 1 To Nstep
                    b1 = b1 + TimeStep(i)
                Next i
                rmeshsum = Ncycle * b1   'ﾒｯｼｭ合計
                df = (Fw2 - Fw1) / rmeshsum
            End If
        End If

        If Nflux > 0 Then
            Call HeatFluxSet(1)    '濃度流束の設定
        End If

        itime = 0
        If Mstat > 0 Then   '非定常の場合
            ReDim Rkc(Nall, mb), Rmc(Nall, mb)

            TimeNew = 0
            itime = 0
            icycle = 0
            istep = 0
            Call ResFile3(itime, icycle, istep) '結果ﾌｧｲﾙへの出力3

            Dim rdate As Date = Now
            date1 = rdate
            time1 = 0
            date2 = date1
            time2 = 0
            itime = 1
            icycle = 1
            Dtime = DtimeInit
            dtime0 = Dtime
            If Nstep = 1 Then
                dtimestd = TimeMax / Ntime
            Else
                dtimestd = TimeStep(1)
                kxcycle = Idcycle
                time0 = 0
                date0 = date1
            End If
            TimeNew = Dtime
            timenext = dtimestd
            newstep = 0
        End If
        istep = 1

        If Namb > 0 Then
            Call HeatTrans(1)  '濃度伝達の計算
        End If

        If Mstat > 0 Then   '非定常の場合
            For i = 1 To Nall
                Fc(i) = Tf(i)
                For j = 1 To mb
                    Rkc(i, j) = Tk(i, j)
                Next j
            Next i
        End If

        aa$ = "要素計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
            Call Store()    '全体ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If Mstat = 0 Then
            '進行表示
            fw0 = Fw1
            fwx = 0.7 * Fw1 + 0.3 * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
        End If

        icheck = 0
        Do
            If Mstat > 0 Then
                Application.DoEvents()
                icount = 0
                For k = 1 To Nall
                    Tf(k) = 2 * Fc(k)
                    j1 = k - mb + 1
                    If j1 < 1 Then
                        j1 = 1
                    End If
                    j2 = k + mb - 1
                    If j2 > Nall Then
                        j2 = Nall
                    End If
                    For j = j1 To j2
                        If k <= j Then
                            ii = j - k + 1
                            kb = k
                        Else
                            ii = k - j + 1
                            kb = j
                        End If
                        b1 = Rkc(kb, ii)
                        Tf(k) = Tf(k) - (b1 - Rmc(kb, ii) * 2 / Dtime) * Tu(j)
                    Next j
                    mx = mb
                    If k + mb - 1 > Nall Then
                        mx = Nall - k + 1
                    End If
                    For j = 1 To mx
                        Tk(k, j) = Rkc(k, j) + Rmc(k, j) * 2 / Dtime
                    Next j
                    If icount < 999 Then
                        icount = icount + 1
                    Else
                        Application.DoEvents()
                        icount = 0
                    End If
                Next k
            End If

            If Nbound > 0 Then
                For ib = 1 To Nbound
                    ix = Nrest(ib)
                    ii = Kcomp(ix)
                    k = Ndim * (ii - 1) + 1
                    ub = ConcFix(ib, istep)
                    Call RestCond(k, mb, ub)     '拘束条件処理
                Next ib
            End If

            Call Solver1(mb)    'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（前進側）

            Tu(Nall) = Tf(Nall) / Tk(Nall, 1)

            Call Solver2(mb)    'ﾊｰﾌﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（後退側）

            Application.DoEvents()
            If Mstat = 0 Then       '定常の場合
                Call ResFile3(itime, icycle, istep)      '結果ﾌｧｲﾙへの出力3
                icheck = 1
            Else                    '非定常の場合
                If Nstep = 1 Then
                    date0 = date1
                    time0 = time1
                End If
                date1 = date2
                time1 = time2
                Dim rdate1 As Date = Now
                date2 = rdate1
                time2 = TimeNew
                If TimeNew > 0.9999 * timenext Then
                    TimeNew = timenext
                    If Nstep = 1 Then
                        icc = 1
                    ElseIf icycle = kxcycle Then
                        icc = 1
                        If istep = Nstep Then
                            kxcycle = kxcycle + Idcycle
                            If kxcycle > Ncycle Then
                                kxcycle = Ncycle
                            End If
                        End If
                    Else
                        icc = 0
                    End If
                    If icc > 0 Then
                        Call ResFile3(itime, icycle, istep)  '結果ﾌｧｲﾙへの出力3
                    End If

                    If Nstep = 1 Then
                        rmesh = itime
                    Else
                        drmesh = timenext - rmesh
                        rmesh = timenext
                    End If
                    If Nstep = 1 Then
                        b1 = time1 - time0
                        If b1 >= Dtime Then
                            sec = TimeLap(date0, date1)
                        Else
                            b1 = Dtime
                            sec = TimeLap(date1, date2)
                        End If
                    Else
                        b1 = time2 - time0
                        sec = TimeLap(date0, date2)
                    End If
                    Call ReqTime(rmesh, rmeshsum, b1, sec)   '残りの所要時間の計算

                    '進行表示
                    fw0 = Fw1
                    If Nstep = 1 Then
                        Fw1 = Fw1 + df
                    Else
                        Fw1 = Fw1 + drmesh * df
                    End If
                    ProgressBar1.Value = 100 * Fw1 / Fw2

                    If Nstep = 1 Then
                        itime = itime + 1
                        timenext = TimeMax * itime / Ntime
                    Else
                        If istep < Nstep Then
                            istep = istep + 1
                        Else
                            icycle = icycle + 1
                            istep = 1
                        End If
                        timenext = timenext + TimeStep(istep)
                        newstep = 1
                    End If
                End If
                If Nstep = 1 Then
                    If itime > Ntime Then
                        icheck = 1
                    End If
                ElseIf icycle > Ncycle Then
                    icheck = 1
                End If
                If icheck = 0 Then
                    If dtime0 < dtimestd Then
                        Call DconcCalc(dconcx)      '最大濃度変化の計算
                        If dtime0 = Dtime Then
                            If dconcx = 0 Or dconcx < 0.5 * DconcMax Then
                                dtime0 = 2 * Dtime
                            End If
                            If dtime0 > 0.999 * dtimestd Then
                                dtime0 = dtimestd
                            End If
                        End If
                        For i = 1 To Nall
                            TUx(i) = Tu(i)
                        Next i
                    End If
                    dtime1 = timenext - TimeNew
                    If newstep = 0 Then
                        If dtime1 < 1.001 * dtime0 Then
                            Dtime = dtime1
                        Else
                            Dtime = dtime0
                        End If
                    Else
                        Dim rdate2 As Date = Now
                        date1 = rdate2
                        time1 = TimeNew
                        date2 = date1
                        time2 = 0
                        time0 = time1
                        date0 = date1
                        Dtime = DtimeInit
                        dtime0 = Dtime
                        dtimestd = TimeStep(istep)
                    End If
                    TimeNew = TimeNew + Dtime

                    If NMdivMax > 0 Or newstep > 0 Then
                        newstep = 0
                        For i = 1 To Nall
                            Tf(i) = 0
                            Fc(i) = 0
                            For j = 1 To mb
                                Tk(i, j) = 0
                                Rkc(i, j) = 0
                                Rmc(i, j) = 0
                            Next j
                        Next i
                        If Nflux > 0 Then
                            Call HeatFluxSet(istep)    '濃度流束の設定
                        End If
                        If Namb > 0 Then
                            Call HeatTrans(istep)  '濃度伝達の計算
                        End If
                        For i = 1 To Nall
                            Fc(i) = Tf(i)
                            For j = 1 To mb
                                Rkc(i, j) = Tk(i, j)
                            Next j
                        Next i

                        aa$ = "要素計算中" + "   "
                        Call TimCal(1, timn$)
                        aa$ = aa$ + timn$
                        gr.Clear(Color.White)
                        gr.DrawString(aa$, fnt, myBrush, 1, 1)

                        Application.DoEvents()
                        icount = 0
                        For ie = 1 To Nelem
                            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
                            Call Store()    '全体ﾏﾄﾘｯｸｽへの蓄積
                            If icount < 99 Then
                                icount = icount + 1
                            Else
                                Application.DoEvents()
                                icount = 0
                            End If
                        Next ie
                    End If
                End If
            End If

            aa$ = "ﾙｰﾌﾟ終了" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Loop Until icheck = 1

        Call ResFile4()     '結果ﾌｧｲﾙへの出力4

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        Label2.Text = "計算結果をファイルへ出力しました。"
        Label3.Text = aa$
        aa$ = "計算が終了しました。"
        Me.BringToFront()
        aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
        If KindBatch = 0 Then
            MsgBox(aa$, 0, "計算確認")
        Else
            Kfinish = 1
        End If
        gr.Dispose()
        Me.Close()

    End Sub
End Class
