'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ｽｶｲﾗｲﾝ法）
Imports System.Drawing

Public Class Diff3DCal5
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(224, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "移流拡散計算の実行（スカイライン法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(147, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(268, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'Diff3DCal5
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Diff3DCal5"
        Me.Text = "Diff3DCal5"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Kinit As Integer        '非定常解析の区分（0:初回、1:次回以降）
    Dim NBvar As Integer        '速度・圧力非ｾﾞﾛ固定の変数の数
    Dim Neff As Integer         '縮小ﾏﾄﾘｯｸｽの行列数
    Dim NumEff As Integer       'FEM1次行列のｲﾝﾃﾞｯｸｽ数
    Dim NumEffT As Integer      'FEM1次行列のｲﾝﾃﾞｯｸｽ数
    Dim Nvf As Integer          '流れ解析における1要素当りの変数の総数

    Dim EpsError As Single      '計算時の誤差率
    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置
    Dim RateMAmax As Single     '非定常の質量・対流比の最大値
    Dim RatePress0 As Single    '前回の入口圧力の修正比
    Dim RatePress1 As Single    '入口圧力の修正比
    Dim Svelold As Single       '前回の速度変化量の最大値
    Dim TauPS As Single         'PSPG係数
    Dim TimeStd As Single       '非定常の初期基準時間
    Dim VelAve0 As Single       '前回の入口の平均流速
    Dim VelAve1 As Single       '入口の平均流速

    Dim Idiag() As Integer      'FEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim IdiagT() As Integer     '濃度のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim KBfix() As Integer      '速度･圧力非ｾﾞﾛ固定の変数番号
    Dim KBkind() As Integer     '固定変数の区分（0:速度、1:圧力）
    Dim KConcRange(2) As Integer    '最低・最高濃度の節点番号 
    Dim KRelax() As Integer     '計算変数の緩和計算有無
    Dim KVarMax(7) As Integer   '最大値の節点番号
    Dim Lcomp() As Integer      '全変数の縮小ﾏﾄﾘｯｸｽ変数番号
    Dim NPrefT() As Integer     '濃度計算における節点濃度の対応番号
    Dim NTrest() As Integer     '濃度固定の有無(0:固定なし、1:固定有り)
    Dim NumDiag() As Integer    'FEM行列対角毎のﾊｰﾌｲﾝﾃﾞｯｸｽ数
    Dim NumDiagT() As Integer   '濃度のFEM行列対角毎のﾊｰﾌｲﾝﾃﾞｯｸｽ数
    Dim Nw() As Integer         '各節点の共通要素数

    Dim Bkx(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKx
    Dim Bky(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKy
    Dim Bkz(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのKz
    Dim CFix() As Double        '固定濃度
    Dim ConcRange(2) As Single  '最低・最高濃度
    Dim Ek(80, 80) As Double    '要素計算の２次配列
    Dim Exx(20, 20) As Double   '非線形項Exx(i,j)
    Dim Exy(20, 20) As Double   '非線形項Exy(i,j)
    Dim Exz(20, 20) As Double   '非線形項Exz(i,j)
    Dim Eyx(20, 20) As Double   '非線形項Eyx(i,j)
    Dim Eyy(20, 20) As Double   '非線形項Eyy(i,j)
    Dim Eyz(20, 20) As Double   '非線形項Eyz(i,j)
    Dim Ezx(20, 20) As Double   '非線形項Ezx(i,j)
    Dim Ezy(20, 20) As Double   '非線形項Ezy(i,j)
    Dim Ezz(20, 20) As Double   '非線形項Ezz(i,j)
    Dim ForceB(20, 4) As Double   '物体力
    Dim HElem() As Single       '要素長
    Dim Hp(20, 20) As Double    'PSPGの圧力項
    Dim Hsx(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsx
    Dim Hsy(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsy
    Dim Hsz(20, 20) As Double   '要素ﾏﾄﾘｯｸｽのHsz
    Dim Hx(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHx
    Dim Hy(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHy
    Dim Hz(20, 20) As Double    '要素ﾏﾄﾘｯｸｽのHz
    Dim PDE(20, 9) As Double    '要素節点での速度の偏微分
    Dim PDVel(,) As Double      '節点での速度の偏微分
    Dim PDVelX(,) As Double     '節点での速度の偏微分(前回)
    Dim PDVelXX(,) As Double    '節点での速度の偏微分(前々回)
    Dim RM(20) As Double        '非定常の節点質量
    Dim TConcRange(2) As Single '最低・最高濃度の時間
    Dim TE(20) As Double        '要素の濃度配列
    Dim TEb(20) As Double       '要素節点の前回濃度
    Dim Tf() As Double          'FEMの右辺項
    Dim Tff() As Double         '流れ計算の右辺ﾍﾞｸﾄﾙ
    Dim Tff0() As Double        '時間0の速度・圧力
    Dim Tffx() As Double        '前時間ｽﾃｯﾌﾟの速度・圧力
    Dim Tft() As Double         '濃度FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tftx() As Double        '前時間ｽﾃｯﾌﾟの濃度
    Dim Tk() As Double          'FEM行列の1次元保存配列
    Dim TimeVMax(7) As Single   '各変数の最大時の時間
    Dim Tr(20, 27) As Single    'ｶﾞｳｽ点・節点の変換ﾏﾄﾘｯｸｽ
    Dim UE(20), VE(20), WE(20) As Double   '要素節点の速度U、V、W
    Dim UEb(20), VEb(20), WEb(20) As Double  '要素節点の前回速度U、V、W
    Dim UG(27), VG(27), WG(27) As Double   'ｶﾞｳｽ点の速度U、V、W
    Dim VarMax(7) As Single     '各変数の最大値
    Dim VBfix() As Double       '速度・圧力の非ｾﾞﾛ固定値
    Dim Vold(), Voldx() As Double '流れ計算の前２回分の解

    Private Sub BandWidth(ByRef mbh As Integer, ByRef mbht As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･濃度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ib, ibx, ie, ii, j, jb, jbx, jj, k, k1, k2, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        mbh = 0 : mbht = 0
        For ie = 1 To Nelem
            ii = 0
            jj = 0
            For i = 1 To nmax
                ib = NNelem(ie, i)
                ibx = Kcomp(ib)
                k1 = 4 * (ibx - 1)
                For j = 1 To 4
                    k1 = k1 + 1
                    k2 = Lcomp(k1)
                    If k2 > 0 Then
                        If ii = 0 Then
                            ii = k2
                            jj = k2
                        ElseIf k2 < ii Then
                            ii = k2
                        ElseIf k2 > jj Then
                            jj = k2
                        End If
                    End If
                Next j
                If i < nmax Then
                    For j = i + 1 To nmax
                        jb = NNelem(ie, j)
                        jbx = Kcomp(jb)
                        k = Math.Abs(ibx - jbx)
                        If k > mbht Then
                            mbht = k
                        End If
                    Next j
                End If
            Next i
            k = jj - ii
            If k > mbh Then
                mbh = k
            End If
        Next ie
        mbh = mbh + 1
        mbht = mbht + 1

    End Sub

    Private Sub CalcParam(ByVal ie As Integer, ByVal kindvisc As Integer)
        '安定化ﾊﾟﾗﾒｰﾀｰの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        Dim numg As Integer
        Dim b0, b1, b2, b3, bf, ce, dj, et, gd, he As Double
        Dim s, t, temp, u As Double

        numg = 0
        If KindElem = 0 Then
            s = 0 : t = 0 : u = 0
            Call ShapeFunc(1, s, t, u)    '形状関数の計算
        End If
        Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        If kindvisc = 0 Or KindFlow = 0 Then
            et = Rmyu
        Else
            Call ShearRate(bf, dj, gd) '剪断速度の計算
            temp = Tempi
            Call ViscEqua(et, gd, temp)     '粘度式計算
        End If
        ce = Math.Sqrt(UG(numg) ^ 2 + VG(numg) ^ 2 + WG(numg) ^ 2)

        If Mstat = 0 Then
            b0 = 0
        Else
            b0 = 2 / Dtime
        End If
        he = HElem(ie)
        b1 = 2 * ce / he
        b2 = 4 * (et / Rou) / (he * he)
        b3 = 1 / Math.Sqrt(b0 * b0 + b1 * b1 + b2 * b2)
        TauPS = Cratio * b3

    End Sub

    Private Sub CalcPrep(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算準備
        'ie･･･要素番号
        Dim i, i2, ii, j, jj, k, kb, kk, m, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        j = 0
        For i = 1 To nmax
            i2 = NNelem(ie, i)
            k = Kcomp(i2)
            XE(i) = Xdata(i2)
            YE(i) = Ydata(i2)
            ZE(i) = Zdata(i2)
            NPrefT(i) = k
            TE(i) = Tft(k)
            kk = 4 * (k - 1) + 1
            For m = 0 To 2
                kb = Lcomp(kk + m)
                Select Case m
                    Case 0
                        If kb = 0 Then
                            UE(i) = 0
                        Else
                            UE(i) = Tff(kb)
                        End If
                    Case 1
                        If kb = 0 Then
                            VE(i) = 0
                        Else
                            VE(i) = Tff(kb)
                        End If
                    Case 2
                        If kb = 0 Then
                            WE(i) = 0
                        Else
                            WE(i) = Tff(kb)
                        End If
                End Select
            Next m

            For ii = 0 To 3
                j = j + 1
                jj = kk + ii
                NPrefer(j) = Lcomp(jj)
            Next ii

            For m = 1 To 9
                PDE(i, m) = PDVel(k, m)
            Next m

        Next i

    End Sub

    Private Sub CalcPrepT(ByVal ie As Integer)
        '非定常の要素ﾏﾄﾘｯｸｽの計算準備
        'ie･･･要素番号
        Dim i, i2, j, k, kb, kk, m, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        Dim b1 As Double
        j = 0
        For i = 1 To nmax
            i2 = NNelem(ie, i)
            k = Kcomp(i2)
            XE(i) = Xdata(i2)
            YE(i) = Ydata(i2)
            ZE(i) = Zdata(i2)
            NPrefT(i) = k
            TE(i) = 0.5 * (Tft(k) + Tftx(k))
            TEb(i) = Tftx(k)
            kk = 4 * (k - 1) + 1
            For m = 0 To 3
                kb = Lcomp(kk + m)
                j = j + 1
                NPrefer(j) = kb
                b1 = 0.5 * (Tff(kb) + Tffx(kb))
                Select Case m
                    Case 0
                        If kb = 0 Then
                            UE(i) = 0
                            UEb(i) = 0
                        Else
                            UE(i) = b1
                            UEb(i) = Tffx(kb)
                        End If
                    Case 1
                        If kb = 0 Then
                            VE(i) = 0
                            VEb(i) = 0
                        Else
                            VE(i) = b1
                            VEb(i) = Tffx(kb)
                        End If
                    Case 2
                        If kb = 0 Then
                            WE(i) = 0
                            WEb(i) = 0
                        Else
                            WE(i) = b1
                            WEb(i) = Tffx(kb)
                        End If
                End Select
            Next m

            For m = 1 To 9
                PDE(i, m) = PDVel(k, m)
            Next m

        Next i

    End Sub

    Private Sub CoefMatrix(ByVal ie As Integer, ByVal kindvisc As Integer, _
    ByVal mtg As Integer)
        '係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        Dim i, i1, i2, i3, i4, ig, j, j1, j2, j3, j4, jg As Integer
        Dim k, kb, kg, kk, numg As Integer
        Dim b1, b2, b3, b4, b5, bf, bsum, dj, dv As Double
        Dim et, g1, g2, g3, gd, s, t, temp, u As Double
        Dim dxvel(3), dyvel(3), dzvel(3), fk(20) As Double

        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    u = PosGaus(kg)
                    numg = numg + 1
                    Call ShapeFunc(1, s, t, u)    '形状関数の計算
                    Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    Call ShapeFunc2(s, t, u)   '形状関数の2階の偏微分計算

                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)

                    If kindvisc = 0 Or KindFlow = 0 Then
                        et = Rmyu
                    Else
                        Call ShearRate(bf, dj, gd) '剪断速度の計算
                        temp = Tempi
                        Call ViscEqua(et, gd, temp)     '粘度式計算
                    End If

                    For k = 1 To 3
                        dxvel(k) = 0
                        dyvel(k) = 0
                        dzvel(k) = 0
                    Next k
                    For i = 1 To 20
                        dxvel(1) = dxvel(1) + Shape(i) * PDE(i, 1)
                        dxvel(2) = dxvel(2) + Shape(i) * PDE(i, 4)
                        dxvel(3) = dxvel(3) + Shape(i) * PDE(i, 7)
                        dyvel(1) = dyvel(1) + Shape(i) * PDE(i, 2)
                        dyvel(2) = dyvel(2) + Shape(i) * PDE(i, 5)
                        dyvel(3) = dyvel(3) + Shape(i) * PDE(i, 8)
                        dzvel(1) = dzvel(1) + Shape(i) * PDE(i, 3)
                        dzvel(2) = dzvel(2) + Shape(i) * PDE(i, 6)
                        dzvel(3) = dzvel(3) + Shape(i) * PDE(i, 9)
                    Next i

                    For j = 1 To 20
                        fk(j) = 0
                    Next j
                    For j = 1 To 20
                        b1 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    b2 = Dss(j)
                                Case 2
                                    b2 = Dtt(j)
                                Case 3
                                    b2 = Duu(j)
                            End Select
                            b1 = b1 + b2 * (RinvJT(1, k) ^ 2 + RinvJT(2, k) ^ 2 + RinvJT(3, k) ^ 2)
                        Next k
                        b3 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    kb = 2
                                    b2 = 2 * Dst(j)
                                Case 2
                                    kb = 3
                                    b2 = 2 * Dtu(j)
                                Case 3
                                    kb = 1
                                    b2 = 2 * Dus(j)
                            End Select
                            b4 = 0
                            For kk = 1 To 3
                                b4 = b4 + RinvJT(kk, k) * RinvJT(kk, kb)
                            Next kk
                            b3 = b3 + b2 * b4
                        Next k
                        fk(j) = b1 + b3
                    Next j

                    For i = 1 To 20
                        g1 = Dx(i) * dxvel(1) + Dy(i) * dxvel(2) + Dz(i) * dxvel(3)
                        g2 = Dx(i) * dyvel(1) + Dy(i) * dyvel(2) + Dz(i) * dyvel(3)
                        g3 = Dx(i) * dzvel(1) + Dy(i) * dzvel(2) + Dz(i) * dzvel(3)
                        For j = 1 To 20
                            b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            b2 = et * b1 * dv
                            Bkx(i, j) = Bkx(i, j) + b2
                            Bky(i, j) = Bky(i, j) + b2
                            Bkz(i, j) = Bkz(i, j) + b2
                            b3 = Shape(i) * dv
                            Hx(i, j) = Hx(i, j) + b3 * Dx(j)
                            Hy(i, j) = Hy(i, j) + b3 * Dy(j)
                            Hz(i, j) = Hz(i, j) + b3 * Dz(j)

                            'P行
                            bsum = fk(j)
                            b4 = Shape(i) * dv
                            Hsx(i, j) = Hsx(i, j) + b4 * Dx(j)
                            Hsy(i, j) = Hsy(i, j) + b4 * Dy(j)
                            Hsz(i, j) = Hsz(i, j) + b4 * Dz(j)
                            b4 = -TauPS * et * bsum * dv / Rou
                            Hsx(i, j) = Hsx(i, j) + Dx(i) * b4
                            Hsy(i, j) = Hsy(i, j) + Dy(i) * b4
                            Hsz(i, j) = Hsz(i, j) + Dz(i) * b4

                            b4 = TauPS * dv / Rou
                            b5 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            Hp(i, j) = Hp(i, j) + b4 * b5

                            If mtg > 0 Then
                                b1 = Rou * Shape(i) * Shape(j) * dv
                                Exx(i, j) = Exx(i, j) + b1 * dxvel(1)
                                Exy(i, j) = Exy(i, j) + b1 * dyvel(1)
                                Exz(i, j) = Exz(i, j) + b1 * dzvel(1)
                                Eyx(i, j) = Eyx(i, j) + b1 * dxvel(2)
                                Eyy(i, j) = Eyy(i, j) + b1 * dyvel(2)
                                Eyz(i, j) = Eyz(i, j) + b1 * dzvel(2)
                                Ezx(i, j) = Ezx(i, j) + b1 * dxvel(3)
                                Ezy(i, j) = Ezy(i, j) + b1 * dyvel(3)
                                Ezz(i, j) = Ezz(i, j) + b1 * dzvel(3)

                                b5 = TauPS * Shape(j) * dv
                                Hsx(i, j) = Hsx(i, j) + b5 * g1
                                Hsy(i, j) = Hsy(i, j) + b5 * g2
                                Hsz(i, j) = Hsz(i, j) + b5 * g3
                            End If
                        Next j
                        If KBodyForce > 0 Then
                            For k = 1 To 3
                                If Accel(k) <> 0 Then
                                    b1 = Rou * Accel(k) * dv
                                    ForceB(i, k) = ForceB(i, k) + Shape(i) * b1
                                    b3 = TauPS * Accel(k) * dv
                                    Select Case k
                                        Case 1
                                            b4 = Dx(i)
                                        Case 2
                                            b4 = Dy(i)
                                        Case 3
                                            b4 = Dz(i)
                                    End Select
                                    ForceB(i, 4) = ForceB(i, 4) + b4 * b3
                                End If
                            Next k
                        End If
                    Next i
                Next kg
            Next jg
        Next ig

        For i = 1 To 20
            i1 = 4 * i - 3
            i2 = i1 + 1
            i3 = i1 + 2
            i4 = i1 + 3
            For j = 1 To 20
                j1 = 4 * j - 3
                j2 = j1 + 1
                j3 = j1 + 2
                j4 = j1 + 3
                Ek(i1, j1) = Bkx(i, j) + Exx(i, j)
                Ek(i1, j2) = Exy(i, j)
                Ek(i1, j3) = Exz(i, j)
                Ek(i2, j1) = Eyx(i, j)
                Ek(i2, j2) = Bky(i, j) + Eyy(i, j)
                Ek(i2, j3) = Eyz(i, j)
                Ek(i3, j1) = Ezx(i, j)
                Ek(i3, j2) = Ezy(i, j)
                Ek(i3, j3) = Bkz(i, j) + Ezz(i, j)
                Ek(i1, j4) = Hx(i, j)
                Ek(i2, j4) = Hy(i, j)
                Ek(i3, j4) = Hz(i, j)
                Ek(i4, j1) = Hsx(i, j)
                Ek(i4, j2) = Hsy(i, j)
                Ek(i4, j3) = Hsz(i, j)
                Ek(i4, j4) = Hp(i, j)
            Next j
        Next i

    End Sub

    Private Sub CoefMatrixT(ByVal ie As Integer, ByVal kindvisc As Integer, _
    ByVal mtg As Integer)
        '非定常の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        Dim i, i1, i2, i3, i4, ig, j, j1, j2, j3, j4, jg As Integer
        Dim k, kb, kg, kk, numg As Integer
        Dim b1, b2, b3, b4, b5, bf, bsum, dj, dv As Double
        Dim et, g1, g2, g3, gd, s, t, temp, u As Double
        Dim dxvel(3), dyvel(3), dzvel(3), fk(20) As Double

        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    u = PosGaus(kg)
                    numg = numg + 1
                    Call ShapeFunc(1, s, t, u)    '形状関数の計算
                    Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    Call ShapeFunc2(s, t, u)   '形状関数の2階の偏微分計算

                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)

                    If kindvisc = 0 Or KindFlow = 0 Then
                        et = Rmyu
                    Else
                        Call ShearRate(bf, dj, gd) '剪断速度の計算
                        temp = Tempi
                        Call ViscEqua(et, gd, temp)     '粘度式計算
                    End If

                    For k = 1 To 3
                        dxvel(k) = 0
                        dyvel(k) = 0
                        dzvel(k) = 0
                    Next k
                    For i = 1 To 20
                        dxvel(1) = dxvel(1) + Shape(i) * PDE(i, 1)
                        dxvel(2) = dxvel(2) + Shape(i) * PDE(i, 4)
                        dxvel(3) = dxvel(3) + Shape(i) * PDE(i, 7)
                        dyvel(1) = dyvel(1) + Shape(i) * PDE(i, 2)
                        dyvel(2) = dyvel(2) + Shape(i) * PDE(i, 5)
                        dyvel(3) = dyvel(3) + Shape(i) * PDE(i, 8)
                        dzvel(1) = dzvel(1) + Shape(i) * PDE(i, 3)
                        dzvel(2) = dzvel(2) + Shape(i) * PDE(i, 6)
                        dzvel(3) = dzvel(3) + Shape(i) * PDE(i, 9)
                    Next i

                    For j = 1 To 20
                        fk(j) = 0
                    Next j
                    For j = 1 To 20
                        b1 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    b2 = Dss(j)
                                Case 2
                                    b2 = Dtt(j)
                                Case 3
                                    b2 = Duu(j)
                            End Select
                            b1 = b1 + b2 * (RinvJT(1, k) ^ 2 + RinvJT(2, k) ^ 2 + RinvJT(3, k) ^ 2)
                        Next k
                        b3 = 0
                        For k = 1 To 3
                            Select Case k
                                Case 1
                                    kb = 2
                                    b2 = 2 * Dst(j)
                                Case 2
                                    kb = 3
                                    b2 = 2 * Dtu(j)
                                Case 3
                                    kb = 1
                                    b2 = 2 * Dus(j)
                            End Select
                            b4 = 0
                            For kk = 1 To 3
                                b4 = b4 + RinvJT(kk, k) * RinvJT(kk, kb)
                            Next kk
                            b3 = b3 + b2 * b4
                        Next k
                        fk(j) = b1 + b3
                    Next j

                    For i = 1 To 20
                        g1 = Dx(i) * dxvel(1) + Dy(i) * dxvel(2) + Dz(i) * dxvel(3)
                        g2 = Dx(i) * dyvel(1) + Dy(i) * dyvel(2) + Dz(i) * dyvel(3)
                        g3 = Dx(i) * dzvel(1) + Dy(i) * dzvel(2) + Dz(i) * dzvel(3)
                        For j = 1 To 20
                            b1 = Rou * Shape(i) * Shape(j) * dv
                            RM(i) = RM(i) + b1

                            b1 = Rou * Shape(i) * Shape(j) * dv / Dtime
                            Bkx(i, j) = Bkx(i, j) + b1
                            Bky(i, j) = Bky(i, j) + b1
                            Bkz(i, j) = Bkz(i, j) + b1
                            ForceB(i, 1) = ForceB(i, 1) + b1 * UEb(j)
                            ForceB(i, 2) = ForceB(i, 2) + b1 * VEb(j)
                            ForceB(i, 3) = ForceB(i, 3) + b1 * WEb(j)

                            b1 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            b2 = 0.5 * et * b1 * dv
                            Bkx(i, j) = Bkx(i, j) + b2
                            Bky(i, j) = Bky(i, j) + b2
                            Bkz(i, j) = Bkz(i, j) + b2
                            ForceB(i, 1) = ForceB(i, 1) - b2 * UEb(j)
                            ForceB(i, 2) = ForceB(i, 2) - b2 * VEb(j)
                            ForceB(i, 3) = ForceB(i, 3) - b2 * WEb(j)

                            b3 = Shape(i) * dv
                            Hx(i, j) = Hx(i, j) + b3 * Dx(j)
                            Hy(i, j) = Hy(i, j) + b3 * Dy(j)
                            Hz(i, j) = Hz(i, j) + b3 * Dz(j)

                            'P行
                            bsum = fk(j)
                            b4 = TauPS * Shape(j) * dv / Dtime
                            Hsx(i, j) = Hsx(i, j) + b4 * Dx(i)
                            Hsy(i, j) = Hsy(i, j) + b4 * Dy(i)
                            Hsz(i, j) = Hsz(i, j) + b4 * Dz(i)
                            b1 = b4 * (Dx(i) * UEb(j) + Dy(i) * VEb(j) + Dz(i) * WEb(j))
                            ForceB(i, 4) = ForceB(i, 4) + b1

                            b4 = Shape(i) * dv
                            Hsx(i, j) = Hsx(i, j) + b4 * Dx(j)
                            Hsy(i, j) = Hsy(i, j) + b4 * Dy(j)
                            Hsz(i, j) = Hsz(i, j) + b4 * Dz(j)

                            b4 = 0.5 * TauPS * et * bsum * dv / Rou
                            Hsx(i, j) = Hsx(i, j) - Dx(i) * b4
                            Hsy(i, j) = Hsy(i, j) - Dy(i) * b4
                            Hsz(i, j) = Hsz(i, j) - Dz(i) * b4
                            b1 = b4 * (Dx(i) * UEb(j) + Dy(i) * VEb(j) + Dz(i) * WEb(j))
                            ForceB(i, 4) = ForceB(i, 4) + b1

                            b4 = TauPS * dv / Rou
                            b5 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                            Hp(i, j) = Hp(i, j) + b4 * b5

                            If mtg > 0 Then
                                b1 = 0.5 * Rou * Shape(i) * Shape(j) * dv
                                Exx(i, j) = Exx(i, j) + b1 * dxvel(1)
                                Exy(i, j) = Exy(i, j) + b1 * dyvel(1)
                                Exz(i, j) = Exz(i, j) + b1 * dzvel(1)
                                b4 = b1 * (dxvel(1) * UEb(j) + dyvel(1) * VEb(j) + dzvel(1) * WEb(j))
                                ForceB(i, 1) = ForceB(i, 1) - b4
                                Eyx(i, j) = Eyx(i, j) + b1 * dxvel(2)
                                Eyy(i, j) = Eyy(i, j) + b1 * dyvel(2)
                                Eyz(i, j) = Eyz(i, j) + b1 * dzvel(2)
                                b4 = b1 * (dxvel(2) * UEb(j) + dyvel(2) * VEb(j) + dzvel(2) * WEb(j))
                                ForceB(i, 2) = ForceB(i, 2) - b4
                                Ezx(i, j) = Ezx(i, j) + b1 * dxvel(3)
                                Ezy(i, j) = Ezy(i, j) + b1 * dyvel(3)
                                Ezz(i, j) = Ezz(i, j) + b1 * dzvel(3)
                                b4 = b1 * (dxvel(3) * UEb(j) + dyvel(3) * VEb(j) + dzvel(3) * WEb(j))
                                ForceB(i, 3) = ForceB(i, 3) - b4

                                'P行
                                b5 = 0.5 * TauPS * Shape(j) * dv
                                b1 = b5 * g1
                                b2 = b5 * g2
                                b3 = b5 * g3
                                Hsx(i, j) = Hsx(i, j) + b1
                                Hsy(i, j) = Hsy(i, j) + b2
                                Hsz(i, j) = Hsz(i, j) + b3
                                ForceB(i, 4) = ForceB(i, 4) - b1 * UEb(j) - b2 * VEb(j) - b3 * WEb(j)
                            End If
                        Next j

                        If KBodyForce > 0 Then
                            For k = 1 To 3
                                If Accel(k) <> 0 Then
                                    b1 = Rou * Accel(k) * dv
                                    ForceB(i, k) = ForceB(i, k) + Shape(i) * b1
                                    b3 = TauPS * Accel(k) * dv
                                    Select Case k
                                        Case 1
                                            b4 = Dx(i)
                                        Case 2
                                            b4 = Dy(i)
                                        Case 3
                                            b4 = Dz(i)
                                    End Select
                                    ForceB(i, 4) = ForceB(i, 4) + b4 * b3
                                End If
                            Next k
                        End If
                    Next i
                Next kg
            Next jg
        Next ig

        For i = 1 To 20
            i1 = 4 * i - 3
            i2 = i1 + 1
            i3 = i1 + 2
            i4 = i1 + 3
            For j = 1 To 20
                j1 = 4 * j - 3
                j2 = j1 + 1
                j3 = j1 + 2
                j4 = j1 + 3
                Ek(i1, j1) = Bkx(i, j) + Exx(i, j)
                Ek(i1, j2) = Exy(i, j)
                Ek(i1, j3) = Exz(i, j)
                Ek(i2, j1) = Eyx(i, j)
                Ek(i2, j2) = Bky(i, j) + Eyy(i, j)
                Ek(i2, j3) = Eyz(i, j)
                Ek(i3, j1) = Ezx(i, j)
                Ek(i3, j2) = Ezy(i, j)
                Ek(i3, j3) = Bkz(i, j) + Ezz(i, j)
                Ek(i1, j4) = Hx(i, j)
                Ek(i2, j4) = Hy(i, j)
                Ek(i3, j4) = Hz(i, j)
                Ek(i4, j1) = Hsx(i, j)
                Ek(i4, j2) = Hsy(i, j)
                Ek(i4, j3) = Hsz(i, j)
                Ek(i4, j4) = Hp(i, j)
            Next j
        Next i

        If mtg > 0 Then
            For i = 1 To 20
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Exx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Exy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Exz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Eyx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Eyy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Eyz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
                b1 = 0
                For j = 1 To 20
                    b2 = Math.Abs(Ezx(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Ezy(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                    b2 = Math.Abs(Ezz(i, j))
                    If b2 > b1 Then
                        b1 = b2
                    End If
                Next j
                If b1 <> 0 Then
                    b2 = Math.Abs(RM(i) / b1)
                    If b2 < RateMAmax Then
                        RateMAmax = b2
                    End If
                End If
            Next i
        End If

    End Sub

    Private Sub ConcAnalysis(ByVal mbht As Integer)
        '濃度解析
        'mbht･･･濃度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim ie, i, icount, ig, ip, j, jg, kg, mbft, nmax, numg As Integer
        Dim b1, b2, b4, concb, diffb, dj, dv As Double
        Dim s, t, u, ub As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        mbft = mbht + mbht - 1
        For i = 1 To Npoint
            Tf(i) = 0
        Next i
        For i = 1 To NumEffT
            Tk(i) = 0
        Next i

        icount = 0
        For ie = 1 To Nelem
            For i = 1 To nmax
                For j = 1 To nmax
                    Ek(i, j) = 0
                Next j
            Next i
            Call CalcPrep(ie)      '要素ﾏﾄﾘｯｸｽの計算準備

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)  '形状関数の計算
                            Call JacobElem(ie, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝﾏﾄﾘｯｸｽの計算

                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            concb = TG(kg)
                            Call StateCalc(1, concb, diffb)   '物性状態の計算
                            For i = 1 To 20
                                For j = 1 To 20
                                    b2 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                    b1 = UG(numg) * Dx(j) + VG(numg) * Dy(j) + WG(numg) * Dz(j)
                                    b4 = Shape(i) * b1
                                    Ek(i, j) = Ek(i, j) + (diffb * b2 + b4) * dv
                                Next j
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If

            Call Store2()   '濃度計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For ip = 1 To Npoint
            If NTrest(ip) > 0 Then
                ub = CFix(ip)
                Call RestCondT(ip, mbht, Npoint, ub)    '拘束条件処理
            End If
        Next ip

        Call Solver1T(mbht, Npoint) '濃度ｿﾙﾊﾞｰ1（LUL分解）

        Call Solver2T(mbht, Npoint) '濃度ｿﾙﾊﾞｰ2（前進・後退処理）

        Call ConcCheck()   '濃度のﾁｪｯｸ
        For i = 1 To Npoint
            Tft(i) = Tf(i)
        Next i

    End Sub

    Private Sub ConcAnalysisT(ByVal mbht As Integer)
        '非定常の濃度解析
        'mbht･･･濃度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim ie, i, icount, ig, ip, j, jg, kg, kx, mbft, nmax, numg As Integer
        Dim b1, b2, b4, concb, diffb, dj, dv As Double
        Dim s, t, u, ub As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        mbft = mbht + mbht - 1
        For i = 1 To Npoint
            Tf(i) = 0
        Next i
        For i = 1 To NumEffT
            Tk(i) = 0
        Next i

        icount = 0
        For ie = 1 To Nelem
            For i = 1 To nmax
                For j = 1 To nmax
                    Ek(i, j) = 0
                Next j
            Next i
            Call CalcPrepT(ie)      '要素ﾏﾄﾘｯｸｽの計算準備

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)  '形状関数の計算
                            Call JacobElem(ie, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝﾏﾄﾘｯｸｽの計算

                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            concb = TG(kg)
                            Call StateCalc(1, concb, diffb)   '物性状態の計算
                            For i = 1 To 20
                                kx = NPrefT(i)
                                For j = 1 To 20
                                    b1 = Shape(i) * Shape(j) * dv / Dtime
                                    b2 = Dx(i) * Dx(j) + Dy(i) * Dy(j) + Dz(i) * Dz(j)
                                    b2 = 0.5 * diffb * b2 * dv
                                    b4 = UG(numg) * Dx(j) + VG(numg) * Dy(j) + WG(numg) * Dz(j)
                                    b4 = 0.5 * Shape(i) * b4 * dv
                                    Ek(i, j) = Ek(i, j) + b1 + b2 + b4
                                    Tf(kx) = Tf(kx) + (b1 - b2 - b4) * TEb(j)
                                Next j
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If

            Call Store2()   '濃度計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For ip = 1 To Npoint
            If NTrest(ip) > 0 Then
                ub = CFix(ip)
                Call RestCondT(ip, mbht, Npoint, ub)    '拘束条件処理
            End If
        Next ip

        Call Solver1T(mbht, Npoint) '濃度ｿﾙﾊﾞｰ1（LUL分解）

        Call Solver2T(mbht, Npoint) '濃度ｿﾙﾊﾞｰ2（前進・後退処理）

        Call ConcCheck()   '濃度のﾁｪｯｸ
        For i = 1 To Npoint
            Tft(i) = Tf(i)
        Next i

    End Sub

    Private Sub ConcCheck()
        '濃度のﾁｪｯｸ・・・負は0に置換
        Dim ip As Integer
        For ip = 1 To Npoint
            If Tf(ip) < 0 Then
                Tf(ip) = 0
            End If
        Next ip

    End Sub

    Private Sub ConcInitSet()
        '初期濃度設定
        Dim i As Integer

        If InitData > 0 Then
            For i = 1 To Npoint
                Tftx(i) = ConcInit(KRcomp(i))
            Next i
        End If
        For i = 1 To Npoint
            If NTrest(i) > 0 Then
                Tftx(i) = CFix(i)
            End If
            Tft(i) = Tftx(i)
        Next i

    End Sub

    Private Sub Debug1(ByVal mh As Integer)
        '全体ﾏﾄﾘｯｸｽを出力して停止
        '非0要素のみ出力
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, fxx$
        Dim i, ic, ii, j, j1, j2, jb, m As Integer
        Dim z1 As Single

        aa$ = ""
        fxx$ = DirOpen$ + "\Diffusion3DDebug.dat"
        ii = FreeFile()
        FileOpen(ii, fxx$, OpenMode.Output)
        For i = 1 To Neff
            aa$ = "行" + Str(i)
            WriteLine(ii, aa$)
            j1 = i - NumDiag(i) + 1
            If j1 < 1 Then
                j1 = 1
            End If
            j2 = i + mh - 1
            If j2 > Neff Then
                j2 = Neff
            End If
            ic = 0
            For j = j1 To j2
                If j <= i Then
                    jb = Idiag(i) - (i - j)
                Else
                    m = j - i
                    If m < NumDiag(j) Then
                        jb = Idiag(j) + m
                    Else
                        jb = 0
                    End If
                End If
                If jb > 0 Then
                    z1 = Tk(jb)
                    If z1 <> 0 Then
                        If ic = 0 Then
                            aa$ = Str$(j) + ",  " + Str$(z1)
                        Else
                            aa$ = aa$ + ",   " + Str$(j) + ",  " + Str$(z1)
                        End If
                        If ic = 4 Then
                            PrintLine(ii, aa$)
                            ic = 0
                        Else
                            ic = ic + 1
                        End If
                    End If

                End If
            Next j
            If ic > 0 Then
                PrintLine(ii, aa$)
            End If
            z1 = Tf(i)
            WriteLine(ii, "    右辺", z1)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug3(ByVal nx As Integer)
        '右辺ﾍﾞｸﾄﾙを出力して停止
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ii As Integer
        Dim z1 As Single

        fxx$ = DirOpen$ + "\Diffusion3DDebug.dat"
        ii = FreeFile()
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "変数番号、右辺値"
        For i = 1 To nx
            aa$ = Str(i)
            z1 = Tf(i)
            aa$ = aa$ + ",   " + Str(z1)
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DvelCalc(ByRef dvelx As Double)
        '最大速度変化の計算
        'dvelx･･･最大速度変化値
        Dim ip, j, jj, k As Integer
        Dim b1 As Double
        dvelx = 0
        For ip = 1 To Npoint
            j = 4 * (ip - 1) + 1
            For k = 0 To 2
                jj = Lcomp(j + k)
                If jj > 0 Then
                    b1 = Math.Abs(Tff(jj) - Tffx(jj))
                    If b1 > dvelx Then
                        dvelx = b1
                    End If
                End If
            Next k
        Next ip

    End Sub

    Private Sub ElemLengthCalc()
        '要素長の計算
        Dim ie, ig, jg, kg, numg As Integer
        Dim dj, dv, s, t, u, vsum As Double
        ReDim HElem(Nelem)

        For ie = 1 To Nelem
            Call CalcPrep(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
            vsum = 0
            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)    '形状関数の計算
                            Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            vsum = vsum + dv
                        Next kg
                    Next jg
                Next ig
            End If
            HElem(ie) = (6 * vsum / Pai) ^ 0.3333
        Next ie

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal kindvisc As Integer, _
        ByVal mtg As Integer)
        '流れの要素ﾏﾄﾘｯｸｽ計算
        'ie･･･要素番号
        'kindvisc･･･粘度式計算の有無（0:なし、1:有り）
        'mtg･･･対流項の有無（0:なし、1:有り)
        Dim i, j, nmax As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvf
            For j = 1 To Nvf
                Ek(i, j) = 0
            Next j
        Next i
        For i = 1 To nmax
            RM(i) = 0
            For j = 1 To nmax
                Bkx(i, j) = 0
                Bky(i, j) = 0
                Bkz(i, j) = 0
                Exx(i, j) = 0
                Exy(i, j) = 0
                Exz(i, j) = 0
                Eyx(i, j) = 0
                Eyy(i, j) = 0
                Eyz(i, j) = 0
                Ezx(i, j) = 0
                Ezy(i, j) = 0
                Ezz(i, j) = 0
                Hsx(i, j) = 0
                Hsy(i, j) = 0
                Hsz(i, j) = 0
                Hx(i, j) = 0
                Hy(i, j) = 0
                Hz(i, j) = 0
                Hp(i, j) = 0
            Next j
            For j = 1 To 4
                ForceB(i, j) = 0
            Next j
        Next i
        If Mstat = 0 Then
            Call CalcPrep(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
        Else
            Call CalcPrepT(ie)       '要素ﾏﾄﾘｯｸｽの計算準備
        End If
        Call CalcParam(ie, kindvisc)   '安定化ﾊﾟﾗﾒｰﾀｰの計算
        If Mstat = 0 Then
            If KindElem = 0 Then
                Call CoefMatrix(ie, kindvisc, mtg)  '係数ﾏﾄﾘｯｸｽの計算
            End If
        Else
            If KindElem = 0 Then
                Call CoefMatrixT(ie, kindvisc, mtg)  '係数ﾏﾄﾘｯｸｽの計算
            End If
        End If

    End Sub

    Private Sub FluctCheckV(ByRef bb As Double, ByRef bba As Double)
        '速度の発散ﾁｪｯｸ
        'bb･･･速度解変化量の最大値
        'bba･･･収束基準量（速度解最大値×収束基準変化率）
        Dim i, ip, k, kb As Integer
        Dim aa, cc, dd As Double
        Dim b1, b2 As Single
        Dim kk As Integer
        aa = 0
        bb = 0
        For ip = 1 To Npoint
            k = 4 * (ip - 1) + 1
            For i = 0 To 2
                kb = Lcomp(k + i)
                If kb > 0 Then
                    cc = Math.Abs(Tf(kb))
                    dd = Math.Abs(Tf(kb) - Vold(kb))
                    If cc > aa Then
                        aa = cc
                    End If
                    If dd > bb Then
                        bb = dd
                        b1 = Tf(kb)
                        b2 = Vold(kb)
                        kk = kb
                    End If
                End If
            Next i
        Next ip
        bba = aa * EpsCalc

    End Sub

    Public Sub FvolumeCalc(ByVal kout As Integer, ByVal velmax As Double, ByRef zvel1 As Single)
        '要素辺の流出入量の計算
        'kout･･･出力の有無
        'velmax･･･最大流速（絶対値）
        'zvel1･･･入口側の平均流速
        Dim aa$
        Dim i, ib, icc, id, ie, j, jd, jj, jmax As Integer
        Dim k, k1, k2, kgp1, kgp2, kind, kb, kk, kmax, kx, m, nmax, numg As Integer
        Dim zarea, zarea1, zarea2, zqv, zqv1, zqv2 As Single
        Dim zvel, zvel2 As Single
        Dim b1, da, dj, gp1, gp2, ugb, velcut, veln, vgb, wgb As Double
        Dim kbuf(8) As Integer
        Dim gpos(3), sbuf(2, 3), snbuf(3), svbuf(2, 3) As Double
        ReDim KdrawElem(Nelem), KSelem(Nelem, 6)

        If KindElem = 0 Then
            jmax = 8
            kmax = 6
            nmax = 20
        End If
        velcut = velmax * 0.00001

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie
        Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ

        If kout > 0 Then
            SwK.WriteLine("＊＊ 要素面の流出入量の出力 ＊＊")
            SwK.WriteLine("＜要素番号、面番号、面積、流出量、平均流速＞")
        End If

        zarea1 = 0 : zarea2 = 0 '流入、流出の合計面積
        zqv1 = 0 : zqv2 = 0 '流入、流出の合計量
        For ie = 1 To Nelem
            For k = 1 To kmax
                If KSelem(ie, k) = 0 Then   '外郭面の場合
                    If KindElem = 0 Then
                        Call SurfaceSet(ie, k, KsurfPoint)    '面の設定
                    End If
                    icc = 0
                    For j = 1 To jmax
                        kb = Kcomp(KsurfPoint(j))
                        kx = 4 * (kb - 1) + 1
                        For m = 0 To 2
                            If Lcomp(kx + m) > 0 Then
                                icc = 1
                                Exit For
                            End If
                        Next m
                    Next j
                    If icc > 0 Then
                        If KindElem = 0 Then
                            Call SurfaceCond(k, kind, kbuf, gpos)
                            '境界条件用の面設定
                        End If

                        For i = 1 To nmax
                            ib = NNelem(ie, i)
                            XE(i) = Xdata(ib)
                            YE(i) = Ydata(ib)
                            ZE(i) = Zdata(ib)
                            kx = 4 * (Kcomp(ib) - 1) + 1
                            For m = 0 To 2
                                kk = Lcomp(kx + m)
                                Select Case m
                                    Case 0
                                        UE(i) = Tff(kk)
                                    Case 1
                                        VE(i) = Tff(kk)
                                    Case 2
                                        WE(i) = Tff(kk)
                                End Select
                            Next m
                        Next i

                        zarea = 0   '面積
                        zqv = 0     '流出入量
                        If KindElem = 0 Then
                            Select Case kind
                                Case 1
                                    kgp1 = 1
                                    kgp2 = 2
                                    jj = 3
                                Case 2
                                    kgp1 = 1
                                    kgp2 = 3
                                    jj = 2
                                Case 3
                                    kgp1 = 2
                                    kgp2 = 3
                                    jj = 1
                            End Select

                            numg = 0
                            For k1 = 1 To Ngaus
                                gp1 = PosGaus(k1)
                                For k2 = 1 To Ngaus
                                    gpos(kgp1) = gp1
                                    gpos(kgp2) = PosGaus(k2)
                                    gp2 = gpos(kgp2)
                                    numg = numg + 1
                                    Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                                    '形状関数の計算

                                    Call JacobElem2S(1, ie, numg, dj, kbuf)
                                    '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                    ugb = UG(numg)
                                    vgb = VG(numg)
                                    wgb = WG(numg)
                                    da = 0
                                    For i = 1 To 3
                                        b1 = RinvJ(i, jj)
                                        da = da + b1 * b1
                                    Next i
                                    da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                                    zarea = zarea + da

                                    '面の法線ﾍﾞｸﾄﾙの計算
                                    For j = 1 To 2
                                        For m = 1 To 2
                                            If m = 1 Then
                                                Select Case j
                                                    Case 1
                                                        gpos(kgp1) = gp1 - 0.01
                                                    Case 2
                                                        gpos(kgp1) = gp1
                                                        gpos(kgp2) = gp2 - 0.01
                                                End Select
                                            Else
                                                Select Case j
                                                    Case 1
                                                        gpos(kgp1) = gp1 + 0.01
                                                    Case 2
                                                        gpos(kgp2) = gp2 + 0.01
                                                End Select
                                            End If
                                            Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                                            '形状関数の計算

                                            Call JacobElem2S(0, ie, numg, dj, kbuf)
                                            '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                            sbuf(m, 1) = XG(numg)
                                            sbuf(m, 2) = YG(numg)
                                            sbuf(m, 3) = ZG(numg)
                                        Next m
                                        For jd = 1 To 3
                                            svbuf(j, jd) = sbuf(2, jd) - sbuf(1, jd)
                                        Next jd
                                    Next j
                                    snbuf(1) = svbuf(1, 2) * svbuf(2, 3) - svbuf(1, 3) * svbuf(2, 2)
                                    snbuf(2) = svbuf(1, 3) * svbuf(2, 1) - svbuf(1, 1) * svbuf(2, 3)
                                    snbuf(3) = svbuf(1, 1) * svbuf(2, 2) - svbuf(1, 2) * svbuf(2, 1)
                                    id = 0
                                    If kind = 2 Then
                                        If gpos(2) > 0 Then
                                            id = 1
                                        End If
                                    Else
                                        If gpos(jj) < 0 Then
                                            id = 1
                                        End If
                                    End If
                                    If id > 0 Then
                                        For m = 1 To 3
                                            snbuf(m) = -snbuf(m)
                                        Next m
                                    End If
                                    b1 = 0
                                    For m = 1 To 3
                                        b1 = b1 + snbuf(m) * snbuf(m)
                                    Next m
                                    b1 = Math.Sqrt(b1)
                                    For m = 1 To 3
                                        snbuf(m) = snbuf(m) / b1
                                    Next m

                                    veln = ugb * snbuf(1) + vgb * snbuf(2)
                                    veln = veln + wgb * snbuf(3)
                                    zqv = zqv + veln * da
                                Next k2
                            Next k1
                        End If

                        zvel = zqv / zarea
                        If Math.Abs(zvel) > velcut Then
                            If kout > 0 Then
                                aa$ = Str$(ie)
                                aa$ = aa$ + ",  " + Str$(k)
                                aa$ = aa$ + ",  " + Str$(zarea)
                                aa$ = aa$ + ",  " + Str$(zqv)
                                aa$ = aa$ + ",  " + Str$(zvel)
                                SwK.WriteLine(aa$)
                            End If
                            If zqv < 0 Then
                                zqv1 = zqv1 + zqv
                                zarea1 = zarea1 + zarea
                            Else
                                zqv2 = zqv2 + zqv
                                zarea2 = zarea2 + zarea
                            End If
                        End If
                    End If
                End If
            Next k
        Next ie
        If zarea1 = 0 Then
            zvel1 = 0
        Else
            zvel1 = zqv1 / zarea1
        End If
        If zarea2 = 0 Then
            zvel2 = 0
        Else
            zvel2 = zqv2 / zarea2
        End If
        If kout > 0 Then
            SwK.WriteLine("［流入側合計］")
            aa$ = "  面積" + "," + Str(zarea1)
            SwK.WriteLine(aa$)
            aa$ = "  流量" + "," + Str(zqv1)
            SwK.WriteLine(aa$)
            aa$ = "  平均流速" + "," + Str(zvel1)
            SwK.WriteLine(aa$)
            SwK.WriteLine("［流出側合計］")
            aa$ = "  面積" + "," + Str(zarea2)
            SwK.WriteLine(aa$)
            aa$ = "  流量" + "," + Str(zqv2)
            SwK.WriteLine(aa$)
            aa$ = "  平均流速" + "," + Str(zvel2)
            SwK.WriteLine(aa$)
        End If

    End Sub

    Sub ShapeFunc2N(ByVal s As Single, ByVal t As Single, ByVal u As Single)
        '形状関数の2階の偏微分計算2N
        'kind･･･計算区分（0:基本、1:偏微分込み）
        's･･･要素のξ座標
        't･･･要素のη座標
        'u･･･要素のζ座標

        Dss(1) = 4
        Dst(1) = 4
        Dss(2) = -8
        Dst(2) = -4
        Dss(3) = 4
        Dst(3) = 0
        Dss(4) = 0
        Dst(4) = 4
        Dss(5) = 0
        Dst(5) = 0
        Dss(6) = 0
        Dst(6) = -4
        Dss(7) = 0
        Dst(7) = 0
        Dss(8) = 0
        Dst(8) = 0
        Dss(9) = 0
        Dst(9) = 0
        Dss(10) = 0
        Dst(10) = 0

        Dtt(1) = 4
        Dtu(1) = 4
        Dtt(2) = 0
        Dtu(2) = 0
        Dtt(3) = 0
        Dtu(3) = 0
        Dtt(4) = 0
        Dtt(4) = 0
        Dtt(5) = 4
        Dtu(5) = 0
        Dtt(6) = -8
        Dtu(6) = -4
        Dtt(7) = 0
        Dtu(7) = -4
        Dtt(8) = 0
        Dtu(8) = 0
        Dtt(9) = 0
        Dtu(9) = 4
        Dtt(10) = 0
        Dtu(10) = 0

        Duu(1) = 4
        Dus(1) = 4
        Duu(2) = 0
        Dus(2) = -4
        Duu(3) = 0
        Dus(3) = 0
        Duu(4) = 0
        Dus(4) = 0
        Duu(5) = 0
        Dus(5) = 0
        Duu(6) = 0
        Dus(6) = 0
        Duu(7) = -8
        Dus(7) = -4
        Duu(8) = 0
        Dus(8) = 4
        Duu(9) = 0
        Dus(9) = 0
        Duu(10) = 4
        Dus(10) = 0

    End Sub

    Private Sub InitDataSet()
        '初期値設定
        Dim i, ib, j, jj, k, kb As Integer
        If InitDataV > 0 Then
            For i = 1 To Npoint
                ib = Kcomp(i)
                k = 4 * (ib - 1)
                For j = 1 To 4
                    jj = k + j
                    kb = Lcomp(jj)
                    If kb > 0 Then
                        Tffx(kb) = Vinit(i, j)
                    End If
                Next j
            Next i
        End If
        For i = 1 To NBvar
            kb = KBfix(i)
            Tffx(kb) = VBfix(i)
        Next i
        For i = 1 To Neff
            Tff(i) = Tffx(i)
            Vold(i) = Tffx(i)
            Voldx(i) = Tffx(i)
        Next i

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, ic, icc, ie, imax, ip, j, jb, jj, jmax, jx, k, kb, nex As Integer
        Dim b1 As Single
        Dim kbuf(8) As Integer

        If KindElem = 0 Then
            Nvf = 80
            imax = 6
            jmax = 8
        End If
        '速度・圧力固定ﾃﾞｰﾀの処理
        Dim jfix(Npoint, 4) As Integer
        Dim vfix(Npoint, 4) As Single
        If NboundPV > 0 Then
            For i = 1 To NboundPV
                k = Kcomp(NrestPV(i))
                For j = 1 To 4
                    jfix(k, j) = JfixP(i, j)
                    vfix(k, j) = VfixP(i, j)
                Next j
            Next i
        End If
        If NboundSV > 0 Then
            For i = 1 To NboundSV
                ie = KsurfRestV(i, 1)
                kb = KsurfRestV(i, 2)
                If KindElem = 0 Then
                    Call SurfaceSet(ie, kb, kbuf)   '面の設定
                End If
                For j = 1 To jmax
                    k = Kcomp(kbuf(j))
                    For jj = 1 To 4
                        jx = JfixS(i, jj)
                        If jx > 0 Then
                            If jfix(k, jj) = 0 Then
                                jfix(k, jj) = jx
                                vfix(k, jj) = VfixS(i, jj)
                            End If
                        ElseIf jx < 0 Then
                            jfix(k, jj) = jx
                            vfix(k, jj) = VfixS(i, jj)
                        End If
                    Next jj
                Next j
            Next i
        End If

        If KindWall = 0 Then    '壁面の自動設定の場合
            ReDim KdrawElem(Nelem), KSelem(Nelem, 6)
            For ie = 1 To Nelem
                KdrawElem(ie) = 1
            Next ie
            Call InnerCheck2(1, Nelem)    '内面ﾁｪｯｸ
            For ie = 1 To Nelem
                For i = 1 To imax
                    If KSelem(ie, i) = 0 Then   '外郭面の場合
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, i, kbuf)   '面の設定
                        End If
                        ic = 0 '壁面ﾌﾗｯｸﾞのｸﾘｱ（1は壁面にしない）
                        jb = 0
                        For j = 1 To jmax
                            k = Kcomp(kbuf(j))
                            For jj = 1 To 3
                                jx = jfix(k, jj)
                                If jx < 0 Then
                                    If j = jb Or j = jb + 1 Then
                                        jb = j
                                    Else
                                        jb = -1 '強制非壁面でない
                                    End If
                                ElseIf jx > 0 And vfix(k, jj) <> 0 Then
                                    ic = 1
                                    Exit For
                                End If
                            Next jj
                            If ic > 0 Then
                                Exit For
                            End If
                        Next j
                        If jb = jmax Then
                            ic = 1
                        End If
                        If ic = 0 Then
                            icc = 0
                            For j = 1 To jmax
                                k = Kcomp(kbuf(j))
                                If jfix(k, 4) = 0 Then
                                    icc = 1
                                    Exit For
                                End If
                            Next j
                            If icc = 0 Then
                                ic = 1
                            End If
                        End If
                        If ic = 0 Then  '壁面の場合
                            KSelem(ie, i) = -1
                        End If
                    End If
                Next i
            Next ie
            For ie = 1 To Nelem
                For i = 1 To imax
                    If KSelem(ie, i) < 0 Then   '壁面の場合
                        If KindElem = 0 Then
                            Call SurfaceSet(ie, i, kbuf)   '面の設定
                        End If
                        For j = 1 To jmax
                            k = Kcomp(kbuf(j))
                            For jj = 1 To 3
                                jfix(k, jj) = 1
                                vfix(k, jj) = 0
                            Next jj
                        Next j
                    End If
                Next i
            Next ie
        End If

        '濃度固定ﾃﾞｰﾀの処理
        ReDim NTrest(Npoint), CFix(Npoint)
        If NboundP > 0 Then
            For i = 1 To NboundP
                k = Kcomp(NrestP(i))
                NTrest(k) = 1
                CFix(k) = ConcFixP(i, 1)
            Next i
        End If
        If NboundS > 0 Then
            For i = 1 To NboundS
                ie = KsurfRest(i, 1)
                kb = KsurfRest(i, 2)
                If KindElem = 0 Then
                    Call SurfaceSet(ie, kb, kbuf)   '面の設定
                End If
                For j = 1 To jmax
                    k = Kcomp(kbuf(j))
                    If NTrest(k) = 0 Then
                        NTrest(k) = 1
                        CFix(k) = ConcFixS(i, 1)
                    End If
                Next j
            Next i
        End If

        ReDim NPrefer(Nvf), NPrefT(20)
        Nall = Npoint * 4
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i

        nex = 0
        For ip = 1 To Npoint    '0固定の速度･圧力変数の除去
            jb = 4 * (ip - 1)
            For j = 1 To 4
                If jfix(ip, j) <> 0 And vfix(ip, j) = 0 Then
                    jj = jb + j
                    If Lcomp(jj) > 0 Then
                        nex = nex + 1
                        Lcomp(jj) = 0
                    End If
                End If
            Next j
        Next ip

        Neff = Nall - nex
        j = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                j = j + 1
                Lcomp(i) = j
            End If
        Next i

        '速度･圧力の非ｾﾞﾛ固定の整理
        NBvar = 0
        For ip = 1 To Npoint
            For j = 1 To 4
                If jfix(ip, j) <> 0 And vfix(ip, j) <> 0 Then
                    NBvar = NBvar + 1
                End If
            Next j
        Next ip
        ReDim KBfix(NBvar), KBkind(NBvar), VBfix(NBvar)
        i = 0 : jb = 0
        RatePress1 = 1
        For ip = 1 To Npoint
            For j = 1 To 4
                i = i + 1
                b1 = vfix(ip, j)
                If jfix(ip, j) <> 0 And b1 <> 0 Then
                    jb = jb + 1
                    KBfix(jb) = Lcomp(i)
                    VBfix(jb) = b1
                    If j = 4 Then
                        KBkind(jb) = 1
                    End If
                End If
            Next j
        Next ip

        ReDim KRelax(Neff)
        For i = 1 To Neff
            KRelax(i) = 1
        Next i
        For i = 1 To NBvar
            KRelax(KBfix(i)) = 0
        Next i

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3)
        PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1)
        WeightG(2) = 0.88888889

    End Sub

    Private Sub InitialSet2(ByVal mb As Integer, ByVal mbt As Integer)
        '初期設定2
        'mb･･･流れ解析のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbt･･･濃度解析のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$
        Dim i, i1, ib, ic, id, ie, ii, ip, j, k, k1, kk As Integer
        Dim nmax, num, numall, numallT As Integer
        Dim b1, freemem, reqmem As Single
        Dim nbuf(Npoint) As Integer

        If KindElem = 0 Then
            nmax = 20
        End If
        '関連節点数の計算
        numall = 0
        numallT = 0
        For i = 1 To Npoint
            ic = 0
            k = 4 * (i - 1)
            For id = 1 To 4
                If Lcomp(k + id) > 0 Then
                    ic = 1
                    Exit For
                End If
            Next id
            If ic > 0 Then
                For j = 1 To i
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To Nelem
                    ic = 0
                    For ii = 1 To nmax
                        If NNelem(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelem(ie, ii))
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        Next ii
                    End If
                Next ie
                i1 = 0
                For j = 1 To i
                    If nbuf(j) > 0 Then
                        i1 = j
                        Exit For
                    End If
                Next j
                k1 = 0
                For j = i1 To i
                    k = 4 * (j - 1)
                    For id = 1 To 4
                        If Lcomp(k + id) > 0 Then
                            k1 = Lcomp(k + id)
                            Exit For
                        End If
                    Next id
                    If k1 > 0 Then
                        Exit For
                    End If
                Next j
                k = 4 * (i - 1)
                For id = 1 To 4
                    kk = Lcomp(k + id)
                    If kk > 0 Then
                        num = kk - k1 + 1
                        NumDiag(kk) = num
                        numall = numall + num
                        Idiag(kk) = numall
                        numall = numall + num - 1
                    End If
                Next id
            End If

            '濃度関係
            For j = 1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To nmax
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To nmax
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            i1 = 0
            For j = 1 To i
                If nbuf(j) > 0 Then
                    i1 = j
                    Exit For
                End If
            Next j
            num = i - i1 + 1
            NumDiagT(i) = num
            numallT = numallT + num
            IdiagT(i) = numallT
            numallT = numallT + num - 1
        Next i
        NumEff = numall
        NumEffT = numallT

        freemem = 1000 * FreeMemoryGet()
        reqmem = 8.0 * NumEff * 1.05
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "変数の数が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "スカイライン法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(NumEff)

    End Sub

    Private Sub JacobElem(ByVal ie As Integer, ByVal numg As Integer, _
        ByRef dj As Double)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'numg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        Dim c1$, c2$
        Dim i, ii, j, nmax As Integer
        Dim b1 As Double
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To 3
            For j = 1 To 3
                RinvJ(i, j) = 0
                RJmat(i, j) = 0
            Next j
        Next i
        XG(numg) = 0 : YG(numg) = 0 : ZG(numg) = 0
        UG(numg) = 0 : VG(numg) = 0 : WG(numg) = 0
        TG(numg) = 0
        For ii = 1 To nmax
            XG(numg) = XG(numg) + XE(ii) * Shape(ii)
            YG(numg) = YG(numg) + YE(ii) * Shape(ii)
            ZG(numg) = ZG(numg) + ZE(ii) * Shape(ii)
            UG(numg) = UG(numg) + UE(ii) * Shape(ii)
            VG(numg) = VG(numg) + VE(ii) * Shape(ii)
            WG(numg) = WG(numg) + WE(ii) * Shape(ii)
            TG(numg) = TG(numg) + TE(ii) * Shape(ii)
        Next ii

        For ii = 1 To nmax
            For j = 1 To 3
                Select Case j
                    Case 1
                        b1 = XE(ii)
                    Case 2
                        b1 = YE(ii)
                    Case 3
                        b1 = ZE(ii)
                End Select
                RJmat(1, j) = RJmat(1, j) + Ds(ii) * b1
                RJmat(2, j) = RJmat(2, j) + Dt(ii) * b1
                RJmat(3, j) = RJmat(3, j) + Du(ii) * b1
            Next j
        Next ii
        RinvJ(1, 1) = RJmat(2, 2) * RJmat(3, 3) - RJmat(2, 3) * RJmat(3, 2)
        RinvJ(1, 2) = RJmat(1, 3) * RJmat(3, 2) - RJmat(1, 2) * RJmat(3, 3)
        RinvJ(1, 3) = RJmat(1, 2) * RJmat(2, 3) - RJmat(1, 3) * RJmat(2, 2)
        RinvJ(2, 1) = RJmat(2, 3) * RJmat(3, 1) - RJmat(2, 1) * RJmat(3, 3)
        RinvJ(2, 2) = RJmat(1, 1) * RJmat(3, 3) - RJmat(1, 3) * RJmat(3, 1)
        RinvJ(2, 3) = RJmat(1, 3) * RJmat(2, 1) - RJmat(1, 1) * RJmat(2, 3)
        RinvJ(3, 1) = RJmat(2, 1) * RJmat(3, 2) - RJmat(2, 2) * RJmat(3, 1)
        RinvJ(3, 2) = RJmat(1, 2) * RJmat(3, 1) - RJmat(1, 1) * RJmat(3, 2)
        RinvJ(3, 3) = RJmat(1, 1) * RJmat(2, 2) - RJmat(1, 2) * RJmat(2, 1)
        b1 = RJmat(1, 1) * RinvJ(1, 1) + RJmat(1, 2) * RinvJ(2, 1)
        dj = b1 + RJmat(1, 3) * RinvJ(3, 1)

        If dj <= 0 Then
            c1$ = "計算実行エラー"
            c2$ = "要素" + LTrim$(Str$(ie)) + "（ガウス点" + LTrim$(Str$(numg))
            c2$ = c2$ + "）でヤコビアン体積が負か０になりました。"
            MsgBox(c2$, 0, c1$)
            End
        Else
            '本来の逆ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽは下記のようにdjで割った値である。
            For i = 1 To 3
                For j = 1 To 3
                    RinvJT(i, j) = RinvJ(i, j) / dj
                Next j
            Next i
            For ii = 1 To nmax
                For i = 1 To 3
                    b1 = RinvJ(i, 1) * Ds(ii) + RinvJ(i, 2) * Dt(ii)
                    b1 = (b1 + RinvJ(i, 3) * Du(ii)) / dj
                    Select Case i
                        Case 1
                            Dx(ii) = b1
                        Case 2
                            Dy(ii) = b1
                        Case 3
                            Dz(ii) = b1
                    End Select
                Next i
            Next ii
        End If

    End Sub

    Private Sub JacobElem2S(ByVal ic As Integer, ByVal ie As Integer, _
        ByVal numg As Integer, ByRef dj As Double, ByVal knode() As Integer)
        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ic･･･計算区分（0:ｶﾞｳｽ点値のみ、1:全部）
        'ie･･･要素番号
        'numg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        'knode()･･･節点の順位
        Dim i, ii, ip, j, kmax As Integer
        Dim b1 As Double
        If KindElem = 0 Then
            kmax = 8
        End If
        For i = 1 To 3
            For j = 1 To 3
                RinvJ(i, j) = 0
                RJmat(i, j) = 0
            Next j
        Next i
        XG(numg) = 0
        YG(numg) = 0
        ZG(numg) = 0
        UG(numg) = 0
        VG(numg) = 0
        WG(numg) = 0
        For ip = 1 To kmax
            ii = knode(ip)
            XG(numg) = XG(numg) + XE(ii) * Shape(ii)
            YG(numg) = YG(numg) + YE(ii) * Shape(ii)
            ZG(numg) = ZG(numg) + ZE(ii) * Shape(ii)
            UG(numg) = UG(numg) + UE(ii) * Shape(ii)
            VG(numg) = VG(numg) + VE(ii) * Shape(ii)
            WG(numg) = WG(numg) + WE(ii) * Shape(ii)
        Next ip
        If ic > 0 Then
            For ip = 1 To kmax
                ii = knode(ip)
                For j = 1 To 3
                    Select Case j
                        Case 1
                            b1 = XE(ii)
                        Case 2
                            b1 = YE(ii)
                        Case 3
                            b1 = ZE(ii)
                    End Select
                    RJmat(1, j) = RJmat(1, j) + Ds(ii) * b1
                    RJmat(2, j) = RJmat(2, j) + Dt(ii) * b1
                    RJmat(3, j) = RJmat(3, j) + Du(ii) * b1
                Next j
            Next ip
            RinvJ(1, 1) = RJmat(2, 2) * RJmat(3, 3) - RJmat(2, 3) * RJmat(3, 2)
            RinvJ(1, 2) = RJmat(1, 3) * RJmat(3, 2) - RJmat(1, 2) * RJmat(3, 3)
            RinvJ(1, 3) = RJmat(1, 2) * RJmat(2, 3) - RJmat(1, 3) * RJmat(2, 2)
            RinvJ(2, 1) = RJmat(2, 3) * RJmat(3, 1) - RJmat(2, 1) * RJmat(3, 3)
            RinvJ(2, 2) = RJmat(1, 1) * RJmat(3, 3) - RJmat(1, 3) * RJmat(3, 1)
            RinvJ(2, 3) = RJmat(1, 3) * RJmat(2, 1) - RJmat(1, 1) * RJmat(2, 3)
            RinvJ(3, 1) = RJmat(2, 1) * RJmat(3, 2) - RJmat(2, 2) * RJmat(3, 1)
            RinvJ(3, 2) = RJmat(1, 2) * RJmat(3, 1) - RJmat(1, 1) * RJmat(3, 2)
            RinvJ(3, 3) = RJmat(1, 1) * RJmat(2, 2) - RJmat(1, 2) * RJmat(2, 1)
            '逆ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの配列に、面積分で使用するための値を保存する。
        End If

    End Sub

    Private Sub JacobElemC(ByVal ie As Integer, ByVal numg As Integer, _
    ByRef kh As Integer, ByRef dj As Double)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算（ｴﾗｰ停止なし）
        'ie･･･要素番号
        'numg･･･ｶﾞｳｽ点番号
        'kh･･･ｴﾗｰ有無（0:なし、-1:有り）
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        Dim i, ii, j, nmax As Integer
        Dim b1 As Double
        If KindElem = 0 Then
            nmax = 20
        End If
        kh = 0
        For i = 1 To 3
            For j = 1 To 3
                RinvJ(i, j) = 0
                RJmat(i, j) = 0
            Next j
        Next i
        XG(numg) = 0 : YG(numg) = 0 : ZG(numg) = 0
        UG(numg) = 0 : VG(numg) = 0 : WG(numg) = 0
        TG(numg) = 0
        For ii = 1 To nmax
            XG(numg) = XG(numg) + XE(ii) * Shape(ii)
            YG(numg) = YG(numg) + YE(ii) * Shape(ii)
            ZG(numg) = ZG(numg) + ZE(ii) * Shape(ii)
            UG(numg) = UG(numg) + UE(ii) * Shape(ii)
            VG(numg) = VG(numg) + VE(ii) * Shape(ii)
            WG(numg) = WG(numg) + WE(ii) * Shape(ii)
            TG(numg) = TG(numg) + TE(ii) * Shape(ii)
        Next ii

        For ii = 1 To nmax
            For j = 1 To 3
                Select Case j
                    Case 1
                        b1 = XE(ii)
                    Case 2
                        b1 = YE(ii)
                    Case 3
                        b1 = ZE(ii)
                End Select
                RJmat(1, j) = RJmat(1, j) + Ds(ii) * b1
                RJmat(2, j) = RJmat(2, j) + Dt(ii) * b1
                RJmat(3, j) = RJmat(3, j) + Du(ii) * b1
            Next j
        Next ii
        RinvJ(1, 1) = RJmat(2, 2) * RJmat(3, 3) - RJmat(2, 3) * RJmat(3, 2)
        RinvJ(1, 2) = RJmat(1, 3) * RJmat(3, 2) - RJmat(1, 2) * RJmat(3, 3)
        RinvJ(1, 3) = RJmat(1, 2) * RJmat(2, 3) - RJmat(1, 3) * RJmat(2, 2)
        RinvJ(2, 1) = RJmat(2, 3) * RJmat(3, 1) - RJmat(2, 1) * RJmat(3, 3)
        RinvJ(2, 2) = RJmat(1, 1) * RJmat(3, 3) - RJmat(1, 3) * RJmat(3, 1)
        RinvJ(2, 3) = RJmat(1, 3) * RJmat(2, 1) - RJmat(1, 1) * RJmat(2, 3)
        RinvJ(3, 1) = RJmat(2, 1) * RJmat(3, 2) - RJmat(2, 2) * RJmat(3, 1)
        RinvJ(3, 2) = RJmat(1, 2) * RJmat(3, 1) - RJmat(1, 1) * RJmat(3, 2)
        RinvJ(3, 3) = RJmat(1, 1) * RJmat(2, 2) - RJmat(1, 2) * RJmat(2, 1)
        b1 = RJmat(1, 1) * RinvJ(1, 1) + RJmat(1, 2) * RinvJ(2, 1)
        dj = b1 + RJmat(1, 3) * RinvJ(3, 1)

        If dj <= 0 Then
            kh = -1
            Exit Sub
        Else
            '本来の逆ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽは下記のようにdjで割った値である。
            For i = 1 To 3
                For j = 1 To 3
                    RinvJT(i, j) = RinvJ(i, j) / dj
                Next j
            Next i
            For ii = 1 To nmax
                For i = 1 To 3
                    b1 = RinvJ(i, 1) * Ds(ii) + RinvJ(i, 2) * Dt(ii)
                    b1 = (b1 + RinvJ(i, 3) * Du(ii)) / dj
                    Select Case i
                        Case 1
                            Dx(ii) = b1
                        Case 2
                            Dy(ii) = b1
                        Case 3
                            Dz(ii) = b1
                    End Select
                Next i
            Next ii
        End If

    End Sub

    Private Sub MatrixCalc(ByRef iconv As Integer, ByRef ik As Integer, _
        ByVal mbh As Integer, ByVal mbht As Integer, ByRef bb As Double)
        'ﾏﾄﾘｯｸｽ計算
        'iconv･･･収束有無（0:なし、1:有り）
        'ik･･･繰返し回数
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･濃度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'bb･･･最大速度誤差
        Dim aa$, timn$
        Dim i, icount, ie, k, kindvisc, mtg As Integer
        Dim bba, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        iconv = 0
        For i = 1 To Neff
            Tf(i) = 0
        Next i
        For i = 1 To NumEff
            Tk(i) = 0
        Next i

        If ik = 1 Then
            kindvisc = 0
            mtg = 0
        Else
            kindvisc = 1
            mtg = 1
        End If

        icount = 0
        For ie = 1 To Nelem
            aa$ = "要素" + Str$(ie) + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Call ElemMatrix(ie, kindvisc, mtg) '流れの要素ﾏﾄﾘｯｸｽ計算
            Call Store(mbh)       '流れ計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For i = 1 To NBvar
            k = KBfix(i)
            ub = VBfix(i)
            Call RestCond(k, mbh, Neff, ub) '拘束条件処理
        Next i

        Call Solver1(mbh, Neff) '流れｿﾙﾊﾞｰ1（LU分解）
        Call Solver2(mbh, Neff) '流れｿﾙﾊﾞｰ2（前進・後退処理）

        Call PressCheck()   '圧力のﾁｪｯｸ
        For i = 1 To Neff
            Tff(i) = Tf(i)
        Next i

        If KindFlow = 0 And Kconv = 0 Then
            iconv = 1
        Else
            If ik > 1 Then
                Call FluctCheckV(bb, bba)   '速度の発散ﾁｪｯｸ
                If ik > 3 Then
                    If bba >= bb Then
                        iconv = 1
                    End If
                End If
                If ik > 2 Then
                    If bb > Svelold Then
                        Call RelaxVel2()    '速度の緩和2
                        Call RelaxPress2()  '圧力の緩和2
                    End If
                End If
                Call FluctCheckV(bb, bba)   '速度の発散ﾁｪｯｸ
                If ik = NKmax Then
                    If bba >= bb Then
                        iconv = 1
                    End If
                End If
                Svelold = bb
            End If
        End If

        gr.Dispose()

    End Sub

    Private Sub MatrixCalcT(ByVal mbh As Integer, ByVal mbht As Integer)
        'mbh･･･流れ計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        'mbht･･･濃度計算のﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, ie, k, kindvisc, mtg As Integer
        Dim ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        aa$ = ""
        timn$ = ""
        For i = 1 To Neff
            Tf(i) = 0
        Next i
        For i = 1 To NumEff
            Tk(i) = 0
        Next i

        kindvisc = 1
        If KindFlow = 0 And Kconv = 0 Then
            mtg = 0
        Else
            mtg = 1
        End If

        RateMAmax = 1.0E+32

        icount = 0
        For ie = 1 To Nelem
            GoTo Skip1
            aa$ = "要素" + Str$(ie) + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
Skip1:
            Call ElemMatrix(ie, kindvisc, mtg) '流れの要素ﾏﾄﾘｯｸｽ計算
            Call Store(mbh)       '流れ計算ﾏﾄﾘｯｸｽへの蓄積
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For i = 1 To NBvar
            k = KBfix(i)
            ub = VBfix(i)
            Call RestCond(k, mbh, Neff, ub) '拘束条件処理
        Next i

        Call Solver1(mbh, Neff) '流れｿﾙﾊﾞｰ1（LU分解）
        Call Solver2(mbh, Neff) '流れｿﾙﾊﾞｰ2（前進・後退処理）

        Call PressCheck()   '圧力のﾁｪｯｸ
        For i = 1 To Neff
            Tff(i) = Tf(i)
        Next i

        GoTo Skip10
        If Kinit = 0 Then
            Call RelaxTreat0()   '緩和処理
        Else
            Call RelaxTreat()   '緩和処理
        End If
Skip10:
        'GoTo Skip11
        If Kinit > 0 Then
            Call RelaxTreat()   '緩和処理
        End If
Skip11:

        gr.Dispose()

    End Sub

    Private Sub MiniSort(ByRef nsort() As Integer, ByVal work() As Single)
        'ﾐﾆｿｰﾄ
        '同じ変数値の場合に、元の変数順序を保持させるようにソート
        'nsort()･･･元の変数番号のｿｰﾄ順番号
        'work()･･･ｿｰﾄ変数値
        Dim i, j, k, nb, n1, n2 As Integer
        Dim b1 As Single

        i = 1
        Do
            If work(i) = work(i + 1) Then
                b1 = work(i)
                n1 = i
                For j = i + 1 To Npoint
                    If b1 = work(j) Then
                        n2 = j
                    Else
                        Exit For
                    End If
                Next j
                For j = n1 To n2 - 1
                    For k = j + 1 To n2
                        If nsort(j) > nsort(k) Then
                            nb = nsort(j)
                            nsort(j) = nsort(k)
                            nsort(k) = nb
                        End If
                    Next k
                Next j
                i = n2 + 1
            Else
                i = i + 1
            End If
        Loop While i < Npoint

    End Sub

    Private Sub PDiffVelCalc(ByVal ik As Integer)
        '速度偏微分の計算
        'ik･･･繰り返し回数
        Dim i, i2, icount, ie, ig, ii, j, jg, jmax, k, kb, kg, kk, m, nmax, numg As Integer
        Dim b1, dj, s, t, tfb, tfx, tfxx, u As Double
        Dim buf(9), pdbuf(20, 9), pdgbuf(27, 9) As Double

        For i = 1 To Npoint
            For j = 1 To 9
                PDVelXX(i, j) = PDVelX(i, j)
                PDVelX(i, j) = PDVel(i, j)
                PDVel(i, j) = 0
            Next j
        Next i

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If

        If ik > 1 Then
            icount = 0
            For ie = 1 To Nelem
                For i = 1 To nmax
                    i2 = NNelem(ie, i)
                    k = Kcomp(i2)
                    XE(i) = Xdata(i2)
                    YE(i) = Ydata(i2)
                    ZE(i) = Zdata(i2)
                    kk = NdimV * (k - 1) + 1
                    For m = 0 To 2
                        kb = Lcomp(kk + m)
                        Select Case m
                            Case 0
                                If kb = 0 Then
                                    UE(i) = 0
                                Else
                                    UE(i) = Tff(kb)
                                End If
                            Case 1
                                If kb = 0 Then
                                    VE(i) = 0
                                Else
                                    VE(i) = Tff(kb)
                                End If
                            Case 2
                                If kb = 0 Then
                                    WE(i) = 0
                                Else
                                    WE(i) = Tff(kb)
                                End If
                        End Select
                    Next m
                Next i
                If KindElem = 0 Then
                    numg = 0
                    For ig = 1 To Ngaus
                        s = PosGaus(ig)
                        For jg = 1 To Ngaus
                            t = PosGaus(jg)
                            For kg = 1 To Ngaus
                                u = PosGaus(kg)
                                numg = numg + 1
                                Call ShapeFunc(1, s, t, u)    '形状関数の計算
                                Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                                For i = 1 To 9
                                    buf(i) = 0
                                Next i
                                For i = 1 To 20
                                    buf(1) = buf(1) + UE(i) * Dx(i)
                                    buf(2) = buf(2) + UE(i) * Dy(i)
                                    buf(3) = buf(3) + UE(i) * Dz(i)
                                    buf(4) = buf(4) + VE(i) * Dx(i)
                                    buf(5) = buf(5) + VE(i) * Dy(i)
                                    buf(6) = buf(6) + VE(i) * Dz(i)
                                    buf(7) = buf(7) + WE(i) * Dx(i)
                                    buf(8) = buf(8) + WE(i) * Dy(i)
                                    buf(9) = buf(9) + WE(i) * Dz(i)
                                Next i
                                For i = 1 To 9
                                    pdgbuf(numg, i) = buf(i)
                                Next i
                            Next kg
                        Next jg
                    Next ig
                End If

                For i = 1 To nmax
                    For k = 1 To 9
                        pdbuf(i, k) = 0
                    Next k
                    For j = 1 To jmax
                        b1 = Tr(i, j)
                        For k = 1 To 9
                            pdbuf(i, k) = pdbuf(i, k) + b1 * pdgbuf(j, k)
                        Next k
                    Next j
                Next i
                For ii = 1 To nmax
                    i = Kcomp(NNelem(ie, ii))
                    Nw(i) = Nw(i) + 1
                    For k = 1 To 9
                        PDVel(i, k) = PDVel(i, k) + pdbuf(ii, k)
                    Next k
                Next ii
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie

            For i = 1 To Npoint
                If Nw(i) > 1 Then
                    For k = 1 To 9
                        PDVel(i, k) = PDVel(i, k) / Nw(i)
                    Next k
                End If
            Next i

            '緩和処理
            If ik = 2 Then
                For i = 1 To Npoint
                    For k = 1 To 9
                        tfb = PDVel(i, k)
                        tfx = PDVelX(i, k)
                        tfb = RelaxCalFS(tfb, tfx) '緩和計算
                        PDVel(i, k) = tfb
                    Next k
                Next i
            Else
                For i = 1 To Npoint
                    For k = 1 To 9
                        tfb = PDVel(i, k)
                        tfx = PDVelX(i, k)
                        tfxx = PDVelXX(i, k)
                        Call RelaxCalcB(tfb, tfx, tfxx) '緩和計算
                        PDVel(i, k) = tfb
                    Next k
                Next i
            End If

        End If


    End Sub

    Private Sub PDiffVelCalcT()
        '非定常の速度偏微分の計算
        Dim i, i2, icount, ie, ig, ii, j, jg, jmax, k, kb, kg, kk, m, nmax, numg As Integer
        Dim b1, dj, s, t, u As Double
        Dim buf(9), pdbuf(20, 9), pdgbuf(27, 9) As Double

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If
        For i = 1 To Npoint
            Nw(i) = 0
            For j = 1 To 9
                PDVel(i, j) = 0
            Next j
        Next i

        icount = 0
        For ie = 1 To Nelem
            For i = 1 To nmax
                i2 = NNelem(ie, i)
                k = Kcomp(i2)
                XE(i) = Xdata(i2)
                YE(i) = Ydata(i2)
                ZE(i) = Zdata(i2)
                kk = NdimV * (k - 1) + 1
                For m = 0 To 3
                    kb = Lcomp(kk + m)
                    b1 = 0.5 * (Tff(kb) + Tffx(kb))
                    Select Case m
                        Case 0
                            If kb = 0 Then
                                UE(i) = 0
                                UEb(i) = 0
                            Else
                                UE(i) = b1
                                UEb(i) = Tffx(kb)
                            End If
                        Case 1
                            If kb = 0 Then
                                VE(i) = 0
                                VEb(i) = 0
                            Else
                                VE(i) = b1
                                VEb(i) = Tffx(kb)
                            End If
                        Case 2
                            If kb = 0 Then
                                WE(i) = 0
                                WEb(i) = 0
                            Else
                                WE(i) = b1
                                WEb(i) = Tffx(kb)
                            End If
                    End Select
                Next m
            Next i

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            u = PosGaus(kg)
                            numg = numg + 1
                            Call ShapeFunc(1, s, t, u)    '形状関数の計算
                            Call JacobElem(ie, numg, dj)    '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                            For i = 1 To 9
                                buf(i) = 0
                            Next i
                            For i = 1 To 20
                                buf(1) = buf(1) + UE(i) * Dx(i)
                                buf(2) = buf(2) + UE(i) * Dy(i)
                                buf(3) = buf(3) + UE(i) * Dz(i)
                                buf(4) = buf(4) + VE(i) * Dx(i)
                                buf(5) = buf(5) + VE(i) * Dy(i)
                                buf(6) = buf(6) + VE(i) * Dz(i)
                                buf(7) = buf(7) + WE(i) * Dx(i)
                                buf(8) = buf(8) + WE(i) * Dy(i)
                                buf(9) = buf(9) + WE(i) * Dz(i)
                            Next i
                            For i = 1 To 9
                                pdgbuf(numg, i) = buf(i)
                            Next i
                        Next kg
                    Next jg
                Next ig
            End If

            For i = 1 To nmax
                For k = 1 To 9
                    pdbuf(i, k) = 0
                Next k
                For j = 1 To jmax
                    b1 = Tr(i, j)
                    For k = 1 To 9
                        pdbuf(i, k) = pdbuf(i, k) + b1 * pdgbuf(j, k)
                    Next k
                Next j
            Next i
            For ii = 1 To nmax
                i = Kcomp(NNelem(ie, ii))
                Nw(i) = Nw(i) + 1
                For k = 1 To 9
                    PDVel(i, k) = PDVel(i, k) + pdbuf(ii, k)
                Next k
            Next ii
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        For i = 1 To Npoint
            If Nw(i) > 1 Then
                For k = 1 To 9
                    PDVel(i, k) = PDVel(i, k) / Nw(i)
                Next k
            End If
        Next i

    End Sub

    Private Sub PressCheck()
        '圧力のﾁｪｯｸ・・・負圧は0に置換
        Dim ii, ip, j, jj As Integer
        For ip = 1 To Npoint
            ii = Kcomp(ip)
            j = 4 * (ii - 1) + 1
            jj = Lcomp(j + 3)
            If Tf(jj) < 0 Then
                Tf(jj) = 0
            End If
        Next ip

    End Sub

    Private Sub RelaxCalc(ByRef tfb As Double, ByVal tfx As Double, _
        ByVal tfxx As Double)
        '緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        'tfxx･･･前々回値
        Dim b1, b3, b4 As Double
        b1 = tfb - tfx
        b3 = Math.Abs(b1)
        b4 = Math.Abs(tfx - tfxx)
        If b3 > b4 Then
            If b4 = 0 Then
                b4 = 0.2 * b3
            End If
            tfb = tfx + b1 * b4 / b3
        End If
        tfb = (tfb + 3 * tfx + tfxx) / 5
        'tfb = (tfb + 2 * tfx + 3 * tfxx) / 6

    End Sub

    Private Sub RelaxCalc2(ByRef tfb As Double, ByVal tfx As Double)
        '繰返し2回目の緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        Dim b1, b3, b4, c1 As Double

        c1 = 0.1
        b1 = tfb - tfx
        b3 = Math.Abs(b1)
        b4 = Math.Abs(tfx)
        If b3 > c1 * b4 Then
            If b4 = 0 Then
                b4 = 0.2 * b3
            End If
            tfb = tfx + b1 * c1 * b4 / b3
            tfb = 0.5 * (tfb + tfx)
        End If

    End Sub

    Private Sub RelaxCalcB(ByRef tfb As Double, ByVal tfx As Double, _
    ByVal tfxx As Double)
        '緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        'tfxx･･･前々回値
        Dim b1, b2, b3, b4, c1 As Double

        b1 = tfb - tfx
        b3 = Math.Abs(b1)
        b4 = Math.Abs(tfx - tfxx)
        If b3 > 0 Then
            If b4 = 0 Then
                b4 = 0.2 * b3
            End If
            If b4 > 0 Then
                b2 = b3 / b4
                If b2 < 1 Then
                    c1 = 0.5
                ElseIf b2 < 1.703 Then
                    b3 = b2 - 1
                    c1 = 0.5 - b3 * b3
                Else
                    c1 = 0.005
                End If
                tfb = tfx + b1 * c1
            End If
        End If
        tfb = (tfb + 3 * tfx + tfxx) / 5

    End Sub

    Private Function RelaxCalF1(ByVal tfb As Double, ByVal tfx As Double) As Double
        '繰返し2回目の緩和計算F1
        'tfb･･･今回値
        'tfx･･･前回値
        Dim tfnew As Double

        tfnew = 0.5 * (tfb + tfx)
        Return tfnew

    End Function

    Private Function RelaxCalFS(ByVal tfb As Double, ByVal tfx As Double) As Double
        '繰返し2回目の緩和計算
        'tfb･･･今回値
        'tfx･･･前回値
        Dim b1, b2 As Single
        Dim tfnew As Double
        b1 = 0.000001
        b2 = 1 - b1
        tfnew = b1 * tfb + b2 * tfx
        Return tfnew

    End Function

    Private Sub RelaxPress2()
        '圧力の緩和2
        Dim ip, k, kb As Integer
        Dim tfb, tfnew, tfx, tfxx As Double
        For ip = 1 To Npoint
            k = NdimV * (ip - 1) + 4
            kb = Lcomp(k)
            If kb > 0 And KRelax(kb) > 0 Then
                tfb = Tf(kb)
                tfx = Vold(kb)
                tfxx = Voldx(kb)
                tfnew = RelaxCalF1(tfb, tfx) '緩和計算
                Tf(kb) = tfnew
                Tff(kb) = tfnew
            End If
        Next ip

    End Sub

    Private Sub RelaxTreat()
        '非定常の緩和処理
        Dim i As Integer
        Dim b1, b2, c1, t1, tfb As Double

        t1 = TimeNew - TimeStd
        If t1 > 0 Then
            c1 = Dtime / t1
        Else
            c1 = 1.5
        End If
        For i = 1 To Neff
            If KRelax(i) > 0 Then
                tfb = 0.1 * Voldx(i) + 0.85 * Vold(i) + 0.05 * Tf(i)
                b1 = c1 * Math.Abs(Tffx(i) - Tff0(i))
                b2 = Math.Abs(tfb - Tffx(i))
                If b1 > 0 And b2 > b1 Then
                    b2 = b1
                End If
                If tfb < Tffx(i) Then
                    b2 = -b2
                End If
                Tf(i) = Tffx(i) + b2
                Tff(i) = Tf(i)
            End If
        Next i

    End Sub

    Private Sub RelaxTreat0()
        '非定常の緩和処理
        Dim i As Integer
        Dim tfb As Double

        For i = 1 To Neff
            If KRelax(i) > 0 Then
                tfb = 0.1 * Voldx(i) + 0.85 * Vold(i) + 0.05 * Tf(i)
                Tf(i) = tfb
                Tff(i) = Tf(i)
            End If
        Next i

    End Sub

    Private Sub RelaxVel2()
        '速度の緩和2
        Dim i, ip, k, kb As Integer
        Dim tfb, tfx, tfxx As Double
        For ip = 1 To Npoint
            k = NdimV * (ip - 1) + 1
            For i = 0 To 2
                kb = Lcomp(k + i)
                If kb > 0 And KRelax(kb) > 0 Then
                    tfb = Tf(kb)
                    tfx = Vold(kb)
                    tfxx = Voldx(kb)
                    Call RelaxCalc(tfb, tfx, tfxx) '緩和計算
                    Tf(kb) = tfb
                    Tff(kb) = tfb
                End If
            Next i
        Next ip

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ReqTimeT(ByVal rmesh As Single, ByVal rmeshsum As Single, _
    ByVal b1 As Double, ByVal b2 As Single)
        '非定常の残りの所要時間の計算
        'rmesh･･･ﾒｯｼｭ番号
        'rmeshsum･･･最大ﾒｯｼｭ番号
        'b1･･･流れの時間差
        'b2･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b3, b4 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        tima$ = ""
        If b2 < 0 Then
            b2 = b2 + 86400
        End If
        b3 = rmeshsum - rmesh
        b3 = TimeMax * b3 / rmeshsum
        b4 = b2 * b3 / b1
        Call TimConv(tima$, b4)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        Dim aa$, c1$, c2$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜３次元拡散解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)

        aa$ = "解析種類（0:定常、1:非定常）" + "," + Str(Mstat)
        SwK.WriteLine(aa$)
        If Mstat > 0 Then
            c1$ = "計算打切り時間"
            c2$ = "出力時間メッシュ数"
            aa$ = c1$ + "," + Str(TimeMax) + "," + c2$ + "," + Str(Ntime)
            SwK.WriteLine(aa$)
            aa$ = "計算時間間隔の初期値" + "," + Str(DtimeInit)
            SwK.WriteLine(aa$)
            aa$ = "計算1回の速度変化許容値" + "," + Str(DvelMax)
            SwK.WriteLine(aa$)
        End If

        If KindFlow = 0 Then
            SwK.WriteLine("ニュートン流")
        Else
            SwK.WriteLine("非ニュートン流")
        End If

        If KindWall = 0 Then
            SwK.WriteLine("壁面の自動設定有")
        Else
            SwK.WriteLine("壁面の自動設定なし")
        End If

        If Kconv = 0 Then
            SwK.WriteLine("対流項なし")
        Else
            SwK.WriteLine("対流項有り")
        End If

        If Mstat = 0 Then
            If KindFlow > 0 Or Kconv > 0 Then
                aa$ = "最大繰り返し計算回数" + "," + Str(NKmax)
                SwK.WriteLine(aa$)
                aa$ = "収束基準誤差率" + "," + Str(EpsCalc)
                SwK.WriteLine(aa$)
            End If
        End If

        aa$ = "安定化τpの追加係数" + "," + Str(Cratio)
        SwK.WriteLine(aa$)

        SwK.WriteLine("-----------------------------------------------")
    End Sub

    Private Sub ResFile2(ByVal mbf As Integer, ByVal mbft As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mbf･･･流れ計算ﾊﾞﾝﾄﾞ幅(ﾌﾙ)
        'mbft･･･濃度計算ﾊﾞﾝﾄﾞ幅(ﾌﾙ)
        Dim aa$

        SwK.WriteLine("＊＊＊ 計算結果（スカイライン法） ＊＊＊")
        aa$ = "流れ計算マトリックスの変数個数、バンド幅、保存インデックス数"
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Neff) + ",   " + Str(mbf) + ",   " + Str(NumEff)
        SwK.WriteLine(aa$)
        aa$ = "濃度計算マトリックスの変数個数、バンド幅、保存インデックス数"
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Npoint) + ",   " + Str(mbft) + ",   " + Str(NumEffT)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile3(ByVal ikb As Integer, ByRef velmax As Double, _
        ByVal zdvel As Single)
        '結果ﾌｧｲﾙへの出力3
        'ikb･･･計算繰り返し回数
        'velmax･･･最大流速（絶対値）
        'zdvel･･･最大速度誤差
        Dim aa$
        Dim ic, ii, ip, j, jj, k As Integer
        Dim b1, b2 As Double
        Dim zbuf(5) As Single

        aa$ = "計算繰り返し回数" + "," + Str(ikb)
        SwK.WriteLine(aa$)
        If ikb > 1 Then
            aa$ = "最大速度誤差" + "," + Str(zdvel)
            SwK.WriteLine(aa$)
        End If
        SwK.WriteLine("＊＊ 速度・圧力等の出力 ＊＊")
        aa$ = "＜節点番号、速度Ｕ、速度Ｖ、速度Ｗ、圧力、濃度＞"
        SwK.WriteLine(aa$)

        ic = 1
        velmax = 0
        For ip = 1 To Npoint
            ii = Kcomp(ip)
            aa$ = Str$(ip)
            j = 4 * (ii - 1)
            For k = 1 To 3
                jj = Lcomp(j + k)
                b1 = Tff(jj)
                zbuf(k) = b1
                b2 = Math.Abs(b1)
                If b2 > velmax Then
                    velmax = b2
                End If
            Next k
            jj = Lcomp(j + 4)
            zbuf(4) = Tff(jj)
            zbuf(5) = Tft(ii)
            For k = 1 To 5
                aa$ = aa$ + ",  " + Str$(zbuf(k))
            Next k
            SwK.WriteLine(aa$)
            For k = 1 To 4
                If Math.Abs(zbuf(k)) > Math.Abs(VarMax(k)) Then
                    VarMax(k) = zbuf(k)
                    KVarMax(k) = ip
                End If
            Next k
            If ic > 0 Then
                KConcRange(1) = 1
                KConcRange(2) = 1
                ConcRange(1) = zbuf(5)
                ConcRange(2) = zbuf(5)
                ic = 0
            ElseIf zbuf(5) < ConcRange(1) Then
                KConcRange(1) = ip
                ConcRange(1) = zbuf(5)
            ElseIf zbuf(5) > ConcRange(2) Then
                KConcRange(2) = ip
                ConcRange(2) = zbuf(5)
            End If
        Next ip

    End Sub

    Private Sub ResFile3T(ByVal itime As Integer, ByRef velmax As Double)
        '非定常の結果ﾌｧｲﾙへの出力3
        'itime･･･時間ﾒｯｼｭ番号
        'velmax･･･最大速度（絶対値）
        Dim aa$
        Dim ic, ii, ip, j, jj, k As Integer
        Dim b1, b2 As Double
        Dim zbuf(5) As Single

        SwK.WriteLine("-----------------------------------------------")
        aa$ = "＜時間メッシュ番号、時間＞" + "," + Str(itime) + "," + Str(TimeNew)
        SwK.WriteLine(aa$)
        SwK.WriteLine("＊＊ 速度・圧力等の出力 ＊＊")
        aa$ = "＜節点番号、速度Ｕ、速度Ｖ、速度Ｗ、圧力、濃度＞"
        SwK.WriteLine(aa$)

        ic = 0
        If TimeNew = 0 Then
            ic = 1
        End If

        velmax = 0
        For ip = 1 To Npoint
            ii = Kcomp(ip)
            aa$ = Str$(ip)
            j = 4 * (ii - 1)
            For k = 1 To 3
                jj = Lcomp(j + k)
                b1 = Tff(jj)
                zbuf(k) = b1
                b2 = Math.Abs(b1)
                If b2 > velmax Then
                    velmax = b2
                End If
            Next k
            jj = Lcomp(j + 4)
            zbuf(4) = Tff(jj)
            zbuf(5) = Tft(ii)
            For k = 1 To 5
                aa$ = aa$ + ",  " + Str$(zbuf(k))
            Next k
            SwK.WriteLine(aa$)
            For k = 1 To 4
                If Math.Abs(zbuf(k)) > Math.Abs(VarMax(k)) Then
                    VarMax(k) = zbuf(k)
                    KVarMax(k) = ip
                    TimeVMax(k) = TimeNew
                End If
            Next k
            If ic > 0 Then
                KConcRange(1) = 1
                KConcRange(2) = 1
                ConcRange(1) = zbuf(5)
                ConcRange(2) = zbuf(5)
                TConcRange(1) = 0
                TConcRange(2) = 0
                ic = 0
            ElseIf zbuf(5) < ConcRange(1) Then
                KConcRange(1) = ip
                ConcRange(1) = zbuf(5)
                TConcRange(1) = TimeNew
            ElseIf zbuf(5) > ConcRange(2) Then
                KConcRange(2) = ip
                ConcRange(2) = zbuf(5)
                TConcRange(2) = TimeNew
            End If
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim abuf$(7)
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞"
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、   最大値、         節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        abuf$(1) = "速度Ｕ"
        abuf$(2) = "速度Ｖ"
        abuf$(3) = "速度Ｗ"
        abuf$(4) = "圧力"
        abuf$(5) = "剪断速度"
        abuf$(6) = "粘度"
        abuf$(7) = "剪断応力"
        For i = 1 To 7
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(VarMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KVarMax(i))
            SwK.WriteLine(aa$)
            If i < 5 Then
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next i

    End Sub

    Private Sub ResFile4T()
        '非定常の結果ﾌｧｲﾙへの出力4
        Dim aa$, ad$
        Dim abuf$(7)
        Dim i As Integer
        ad$ = "-------------------------------------------------------"
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        CalcRes$ = "＜最大値データ＞"
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、   最大値、         節点番号、   時間"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        abuf$(1) = "速度Ｕ"
        abuf$(2) = "速度Ｖ"
        abuf$(3) = "速度Ｗ"
        abuf$(4) = "圧力"
        abuf$(5) = "剪断速度"
        abuf$(6) = "粘度"
        abuf$(7) = "剪断応力"
        For i = 1 To 7
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(VarMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KVarMax(i)) + ",  "
            aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TimeVMax(i))
            SwK.WriteLine(aa$)
            If i < 5 Then
                CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
            End If
        Next i

    End Sub

    Private Sub ResFile5()
        '結果ﾌｧｲﾙへの出力5
        Dim aa$
        Dim i As Integer
        SwK.WriteLine("＜最低・最高濃度データ＞")
        If KindFmove = 0 Then
            CalcRes$ = "＜最低・最高濃度データ＞"
        Else
            CalcRes$ = CalcRes$ + Cr$ + "＜最低・最高濃度データ＞"
        End If
        If Mstat = 0 Then
            aa$ = "変数項目、    値、            節点番号"
        Else
            aa$ = "変数項目、    値、            節点番号、   時間"
        End If
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$

        For i = 1 To 2
            Select Case i
                Case 1
                    aa$ = "濃度Min"
                Case 2
                    aa$ = "濃度Max"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(ConcRange(i)) + ",  "
            If Mstat = 0 Then
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KConcRange(i))
            Else
                aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KConcRange(i)) + ",  "
                aa$ = aa$ + Space$(44 - Len(aa$)) + Str$(TConcRange(i))
            End If
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mh As Integer, _
        ByVal nx As Integer, ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        'ub･･･拘束値
        Dim it, k2, kb, kbx, m As Integer

        For it = k - NumDiag(k) + 1 To k
            kb = Idiag(k) + it - k
            If it = k Then
                Tk(kb) = 1
            Else
                kbx = Idiag(k) + k - it
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(kbx) * ub
                End If
                Tk(kbx) = 0
                Tk(kb) = 0
            End If
        Next it

        If k < nx Then
            k2 = k + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For it = k + 1 To k2
                m = it - k
                If m < NumDiag(it) Then
                    kb = Idiag(it) + m
                    kbx = Idiag(it) - m
                    If ub <> 0 Then
                        Tf(it) = Tf(it) - Tk(kbx) * ub
                    End If
                    Tk(kbx) = 0
                    Tk(kb) = 0
                End If
            Next it
        End If

        Tf(k) = ub

    End Sub

    Private Sub RestCondT(ByVal k As Integer, ByVal mh As Integer, _
        ByVal nx As Integer, ByVal ub As Double)
        '濃度の拘束条件処理
        'k･･･変数番号
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        'ub･･･拘束値
        Dim it, k2, kb, kbx, m As Integer

        For it = k - NumDiagT(k) + 1 To k
            kb = IdiagT(k) + it - k
            If it = k Then
                Tk(kb) = 1
            Else
                kbx = IdiagT(k) + k - it
                If ub <> 0 Then
                    Tf(it) = Tf(it) - Tk(kbx) * ub
                End If
                Tk(kbx) = 0
                Tk(kb) = 0
            End If
        Next it

        If k < nx Then
            k2 = k + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For it = k + 1 To k2
                m = it - k
                If m < NumDiagT(it) Then
                    kb = IdiagT(it) + m
                    kbx = IdiagT(it) - m
                    If ub <> 0 Then
                        Tf(it) = Tf(it) - Tk(kbx) * ub
                    End If
                    Tk(kbx) = 0
                    Tk(kb) = 0
                End If
            Next it
        End If

        Tf(k) = ub

    End Sub

    Private Sub ShearRate(ByRef bf As Double, ByVal dj As Double, _
        ByRef gd As Double)
        '剪断速度の計算
        'bf･･･ｴﾈﾙｷﾞｰ式のΦ
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        'gd･･･剪断速度
        Dim i, j, jj, k, nmax As Integer
        Dim b1, b2, b3, b4, c5 As Double
        Dim bufx(3), bufy(3), bufz(3) As Double
        Dim dubuf(3), dvbuf(3), dwbuf(3) As Double

        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To nmax
            j = 4 * i - 3
            For k = 0 To 2
                jj = NPrefer(j + k)
                c5 = Tff(jj)
                b1 = Ds(i) * c5
                b2 = Dt(i) * c5
                b3 = Du(i) * c5
                Select Case k
                    Case 0
                        bufx(1) = bufx(1) + b1
                        bufx(2) = bufx(2) + b2
                        bufx(3) = bufx(3) + b3
                    Case 1
                        bufy(1) = bufy(1) + b1
                        bufy(2) = bufy(2) + b2
                        bufy(3) = bufy(3) + b3
                    Case 2
                        bufz(1) = bufz(1) + b1
                        bufz(2) = bufz(2) + b2
                        bufz(3) = bufz(3) + b3
                End Select
            Next k
        Next i
        For i = 1 To 3
            b1 = 0 : b2 = 0 : b3 = 0
            For j = 1 To 3
                b1 = b1 + bufx(j) * RinvJ(i, j)
                b2 = b2 + bufy(j) * RinvJ(i, j)
                b3 = b3 + bufz(j) * RinvJ(i, j)
            Next j
            dubuf(i) = b1 / dj
            dvbuf(i) = b2 / dj
            dwbuf(i) = b3 / dj
        Next i
        b1 = dubuf(2) + dvbuf(1)
        b2 = dvbuf(3) + dwbuf(2)
        b3 = dwbuf(1) + dubuf(3)
        b4 = b1 * b1 + b2 * b2 + b3 * b3
        gd = Math.Sqrt(b4)
        c5 = 2 * (dubuf(1) ^ 2 + dvbuf(2) ^ 2 + dwbuf(3) ^ 2)
        bf = b4 + c5

    End Sub

    Private Sub ShellSort(ByVal kind As Integer)
        'ｼｪﾙｿｰﾄ
        Dim i, ib, j, m As Integer
        Dim varb As Single
        Dim nsort(Npoint) As Integer
        Dim work(Npoint) As Single

        Select Case kind
            Case 1
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Xdata(i)
                Next i
            Case 2
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Ydata(i)
                Next i
            Case 3
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = Zdata(i)
                Next i
        End Select

        m = Npoint
        Do While m > 1
            m = m \ 2
            For j = m + 1 To Npoint
                varb = work(j)
                ib = nsort(j)
                i = j - m
                Do While work(i) >= varb
                    work(i + m) = work(i)
                    nsort(i + m) = nsort(i)
                    i = i - m
                    If i <= 0 Then
                        Exit Do
                    End If
                Loop
                work(i + m) = varb
                nsort(i + m) = ib
            Next j
        Loop

        Call MiniSort(nsort, work)    'ﾐﾆｿｰﾄ

        For i = 1 To Npoint
            Kcomp(nsort(i)) = i
        Next i

    End Sub

    Private Sub Solver1(ByVal mh As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（LU分解）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, icount, ij, ik, j, j1, j2, k, k1, kj, kk, m, m1, m2 As Integer
        Dim b1, b2, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 1
        eps = 1.0E-32
        For j = 2 To mh
            m = j - 1
            If m < NumDiag(j) Then
                ij = Idiag(j) + m
                Tk(ij) = Tk(ij) / Tk(1)
            End If
        Next j
        For kk = 2 To nx
            j = kk
            j2 = j + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For i = j To j2
                m = i - j
                If m < NumDiag(i) Then
                    ij = Idiag(i) - m
                    k1 = i - mh + 1
                    If k1 < 1 Then
                        k1 = 1
                    End If
                    b2 = 0
                    For k = k1 To j - 1
                        m1 = i - k
                        If m1 < NumDiag(i) Then
                            ik = Idiag(i) - m1
                            m2 = j - k
                            If m2 < NumDiag(j) Then
                                kj = Idiag(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = Tk(ij) - b2
                End If
            Next i

            i = kk
            b1 = Tk(Idiag(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ1でﾋﾟﾎﾞｯﾄが0になりました！"
                If Mstat > 0 Then
                    aa$ = aa$ + Chr(13) + Chr(10) + "時間" + Str(TimeNew)
                End If
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For j = i + 1 To j2
                m = j - i
                If m < NumDiag(j) Then
                    ij = Idiag(j) + m
                    j1 = j - mh + 1
                    If j1 < 1 Then
                        j1 = 1
                    End If
                    b2 = 0
                    For k = j1 To i - 1
                        m1 = i - k
                        If m1 < NumDiag(i) Then
                            ik = Idiag(i) - m1
                            m2 = j - k
                            If m2 < NumDiag(j) Then
                                kj = Idiag(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = (Tk(ij) - b2) / b1
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                aa$ = "ｿﾙﾊﾞｰ1 計算中  kk=" + Str$(kk) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                Application.DoEvents()
                icount = 0
            End If
        Next kk

        gr.Dispose()

    End Sub

    Private Sub Solver1T(ByVal mh As Integer, ByVal nx As Integer)
        '濃度のﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ1（LU分解）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, icount, ij, ik, j, j1, j2, k, k1, kj, kk, m, m1, m2 As Integer
        Dim b1, b2, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1T 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0

        eps = 1.0E-20
        For j = 2 To mh
            m = j - 1
            If m < NumDiagT(j) Then
                ij = IdiagT(j) + m
                Tk(ij) = Tk(ij) / Tk(1)
            End If
        Next j
        For kk = 2 To nx
            j = kk
            j2 = j + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For i = j To j2
                m = i - j
                If m < NumDiagT(i) Then
                    ij = IdiagT(i) - m
                    k1 = i - mh + 1
                    If k1 < 1 Then
                        k1 = 1
                    End If
                    b2 = 0
                    For k = k1 To j - 1
                        m1 = i - k
                        If m1 < NumDiagT(i) Then
                            ik = IdiagT(i) - m1
                            m2 = j - k
                            If m2 < NumDiagT(j) Then
                                kj = IdiagT(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = Tk(ij) - b2
                End If
            Next i

            i = kk
            b1 = Tk(IdiagT(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ1Tでﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            For j = i + 1 To j2
                m = j - i
                If m < NumDiagT(j) Then
                    ij = IdiagT(j) + m
                    j1 = j - mh + 1
                    If j1 < 1 Then
                        j1 = 1
                    End If
                    b2 = 0
                    For k = j1 To i - 1
                        m1 = i - k
                        If m1 < NumDiagT(i) Then
                            ik = IdiagT(i) - m1
                            m2 = j - k
                            If m2 < NumDiagT(j) Then
                                kj = IdiagT(j) + m2
                                b2 = b2 + Tk(ik) * Tk(kj)
                            End If
                        End If
                    Next k
                    Tk(ij) = (Tk(ij) - b2) / b1
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next kk

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer, ByVal nx As Integer)
        'ﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, ik, k, k1, k2, m As Integer
        Dim b1, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        '前進処理
        eps = 1.0E-32
        Tf(1) = Tf(1) / Tk(1)
        For i = 2 To nx
            k1 = i - mh + 1
            If k1 < 1 Then
                k1 = 1
            End If
            For k = k1 To i - 1
                m = i - k
                If m < NumDiag(i) Then
                    ik = Idiag(i) - m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
            b1 = Tk(Idiag(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / b1
        Next i

        '後退処理
        For i = nx - 1 To 1 Step -1
            k2 = i + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For k = i + 1 To k2
                m = k - i
                If m < NumDiag(k) Then
                    ik = Idiag(k) + m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2T(ByVal mh As Integer, ByVal nx As Integer)
        '濃度のﾌﾙﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, ik, k, k1, k2, m As Integer
        Dim b1, eps As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2T 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        '前進処理
        eps = 1.0E-20
        Tf(1) = Tf(1) / Tk(1)
        For i = 2 To nx
            k1 = i - mh + 1
            If k1 < 1 Then
                k1 = 1
            End If
            For k = k1 To i - 1
                m = i - k
                If m < NumDiagT(i) Then
                    ik = IdiagT(i) - m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
            b1 = Tk(IdiagT(i))
            If Math.Abs(b1) < eps Then
                aa$ = "ｿﾙﾊﾞｰ2Tでﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / b1
        Next i

        '後退処理
        For i = nx - 1 To 1 Step -1
            k2 = i + mh - 1
            If k2 > nx Then
                k2 = nx
            End If
            For k = i + 1 To k2
                m = k - i
                If m < NumDiagT(k) Then
                    ik = IdiagT(k) + m
                    Tf(i) = Tf(i) - Tk(ik) * Tf(k)
                End If
            Next k
        Next i

        gr.Dispose()

    End Sub

    Private Sub StateCalc(ByVal kmat As Integer, ByVal concmesh As Double, ByRef diffmesh As Double)
        '物性状態の計算
        'kmat･･･材料番号
        'concmesh･･･現在濃度
        'diffmesh･･･現在拡散係数
        Dim i As Integer
        Dim b1, b2 As Double
        If NMdiv(kmat) = 0 Then
            diffmesh = DiffMat(kmat, 0)
        Else
            If concmesh < ConcMat(kmat, 0) Then
                diffmesh = ConcMat(kmat, 0)
            ElseIf concmesh > ConcMat(kmat, NMdiv(kmat)) Then
                diffmesh = ConcMat(kmat, NMdiv(kmat))
            Else
                For i = 1 To NMdiv(kmat)
                    If concmesh <= ConcMat(kmat, i) Then
                        b1 = concmesh - ConcMat(kmat, i - 1)
                        b2 = ConcMat(kmat, i) - concmesh
                        diffmesh = (b1 * DiffMat(kmat, i) + b2 * DiffMat(kmat, i - 1)) / (b1 + b2)
                        Exit For
                    End If
                Next i
            End If
        End If
    End Sub

    Private Sub Store(ByVal mh As Integer)
        '流れ計算ﾏﾄﾘｯｸｽへの蓄積
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, i1, ii, it, j, jt, kb, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To Nvf
            it = NPrefer(i)
            If it > 0 Then
                For j = 1 To Nvf
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it >= jt Then
                            kb = Idiag(it) - (it - jt)
                        Else
                            kb = Idiag(jt) + jt - it
                        End If
                        Tk(kb) = Tk(kb) + Ek(i, j)
                    End If
                Next j
            End If
        Next i
        If KBodyForce > 0 Or Mstat > 0 Then
            For i = 1 To nmax
                i1 = 4 * (i - 1)
                For j = 1 To 4
                    ii = i1 + j
                    it = NPrefer(ii)
                    If it > 0 Then
                        Tf(it) = Tf(it) + ForceB(i, j)
                    End If
                Next j
            Next i
        End If

    End Sub

    Private Sub Store2()
        '濃度計算ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, j, jt, kb, nmax As Integer
        If KindElem = 0 Then
            nmax = 20
        End If
        For i = 1 To nmax
            it = NPrefT(i)
            For j = 1 To nmax
                jt = NPrefT(j)
                If it >= jt Then
                    kb = IdiagT(it) - (it - jt)
                Else
                    kb = IdiagT(jt) + jt - it
                End If
                Tk(kb) = Tk(kb) + Ek(i, j)
            Next j
        Next i
    End Sub

    Private Sub StressCalc()
        '剪断速度・応力の計算
        Dim aa$, timn$
        Dim i, icount, ie, ig, ii, ip, j, jg, jmax, k, kg, kh, nmax, numg As Integer
        Dim b1, b2, b3, bf, dj, et, gd, s, t, temp, u As Double
        Dim nww(Npoint) As Integer    '各節点の共通要素数
        Dim zbuf(3) As Single
        Dim etn(Npoint), she(Npoint) As Double   '各節点の粘度、剪断速度
        Dim etnG(27), sheG(27) As Double   'ｶﾞｳｽ点の粘度、剪断速度
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "剪断速度・応力 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If KindElem = 0 Then
            jmax = 27
            nmax = 20
        End If
        icount = 0
        For ie = 1 To Nelem
            Call CalcPrep(ie)
            For i = 1 To jmax
                sheG(i) = 0
                etnG(i) = 0
            Next i

            If KindElem = 0 Then
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            numg = numg + 1
                            u = PosGaus(kg)
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElemC(ie, numg, kh, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            Call ShearRate(bf, dj, gd) '剪断速度の計算

                            If KindFlow = 0 Then
                                et = Rmyu
                            Else
                                temp = Tempi
                                Call ViscEqua(et, gd, temp)     '粘度式計算
                            End If

                            sheG(numg) = sheG(numg) + gd
                            etnG(numg) = etnG(numg) + et
                        Next kg
                    Next jg
                Next ig
            End If

            For i = 1 To nmax
                b2 = 0 : b3 = 0
                For j = 1 To jmax
                    b1 = Tr(i, j)
                    b2 = b2 + b1 * sheG(j)
                    b3 = b3 + b1 * etnG(j)
                Next j
                ii = Kcomp(NNelem(ie, i))
                she(ii) = she(ii) + b2
                etn(ii) = etn(ii) + b3
            Next i
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        SwK.WriteLine("＊＊ 剪断速度等の出力 ＊＊")
        SwK.WriteLine("＜節点番号、剪断速度、粘度、剪断応力＞")

        For ip = 1 To Npoint
            k = Kcomp(ip)
            aa$ = Str$(ip)
            zbuf(1) = Math.Abs(she(k) / Nw(k))
            zbuf(2) = Math.Abs(etn(k) / Nw(k))
            zbuf(3) = zbuf(1) * zbuf(2)
            For k = 1 To 3
                aa$ = aa$ + ",  " + Str$(zbuf(k))
            Next k
            SwK.WriteLine(aa$)
            For k = 1 To 3
                If Math.Abs(zbuf(k)) > Math.Abs(VarMax(k + 4)) Then
                    VarMax(k + 4) = zbuf(k)
                    KVarMax(k + 4) = ip
                    TimeVMax(k + 4) = TimeNew
                End If
            Next k
        Next ip
        gr.Dispose()

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub ViscEqua(ByRef et As Double, ByVal gd As Double, _
        ByVal temp As Double)
        '粘度式計算
        'et･･･粘度
        'gd･･･剪断速度
        'temp･･･温度
        Dim b1, b2, gdb As Double
        gdb = gd
        If gdb < 1 Then
            gdb = 1
        End If
        If Kvisc > 0 Then
            Select Case Kvisc
                Case 1
                    b1 = Avisc(0) * Math.Exp(Avisc(1) * temp)
                    et = b1 * (gdb ^ Avisc(2))
                Case 2
                    b1 = Math.Log(gdb) / Math.Log(10)
                    b2 = Avisc(0) + Avisc(1) * b1 + Avisc(2) * temp
                    b2 = b2 + Avisc(3) * b1 * b1
                    b2 = b2 + Avisc(4) * b1 * temp + Avisc(5) * temp * temp
                    et = 10 ^ b2
                Case 3
                    b1 = Math.Log(gdb)
                    b2 = Avisc(0) + Avisc(1) * b1 + Avisc(2) * temp
                    b2 = b2 + Avisc(3) * b1 * b1
                    b2 = b2 + Avisc(4) * b1 * temp + Avisc(5) * temp * temp
                    et = Math.Exp(b2)
            End Select
        End If

    End Sub

    Private Sub Diff3DCal5_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, icc, icheck, iconv, ii, ik, ikb, ikmax, itime As Integer
        Dim mbf, mbft, mb, mbh, mbht, mbx As Integer
        Dim b1, df, dtime0, dtime1, dtimestd, freemem As Single
        Dim rmesh, rmeshsum, sec, time0, time1, time2, timenext, zdvel, zvel1 As Single
        Dim dvel, velmax As Double
        Dim date0, date1, date2 As Date
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Fw1 = 0 : Fw2 = 100
        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint), zbuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定
        If KindElem = 0 Then
            Call TrSet(Tr)  '節点応力計算のTr行列の設定
        Else
            Call TrSetN(Tr) 'ｶﾞｳｽ点・節点への変換ﾏﾄﾘｯｸｽ設定N
        End If

        Call BandWidth(mbh, mbht) 'ﾊﾞﾝﾄﾞ幅の計算
        mbf = mbh + mbh - 1
        mbft = mbht + mbht - 1

        ReDim Tf(Neff), Tff(Neff), Vold(Neff), Voldx(Neff)
        ReDim Tft(Npoint)
        If Mstat > 0 Then
            ReDim Tffx(Neff), Tff0(Neff), Tftx(Npoint)
        End If

        ReDim Idiag(Neff), NumDiag(Neff)
        ReDim IdiagT(Npoint), NumDiagT(Npoint)

        ReDim Nw(Npoint)
        ReDim PDVel(Npoint, 9)
        If Mstat = 0 Then
            ReDim PDVelX(Npoint, 9), PDVelXX(Npoint, 9)
        End If

        Call InitialSet2(mbh, mbht)  '初期設定2
        Call ElemLengthCalc()       '要素長の計算

        Call ResFile2(mbf, mbft)    '結果ﾌｧｲﾙへの出力2

        If KindFlow = 0 And Kconv = 0 Then
            ikmax = 1
        Else
            ikmax = NKmax
        End If
        icheck = 0
        If Mstat = 0 Then   '定常の場合
            rmeshsum = ikmax   'ﾒｯｼｭ合計
            rmesh = 0
            icc = 0
            For ik = 1 To ikmax
                aa$ = "計算No." + Str(ik) + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)

                Call PDiffVelCalc(ik)    '速度偏微分の計算

                Application.DoEvents()
                Call MatrixCalc(iconv, ik, mbh, mbht, dvel)
                'ﾏﾄﾘｯｸｽ計算

                Application.DoEvents()
                If ikmax = 1 Or (ik > 1 And iconv > 0) Then
                    icc = 1
                Else
                    For i = 1 To Neff
                        Voldx(i) = Vold(i)
                        Vold(i) = Tff(i)
                    Next i
                End If

                '進行表示
                If icc = 0 Then
                    rmesh = rmesh + 1
                Else
                    ii = ikmax - ik + 1
                    rmesh = rmesh + ii
                End If
                ProgressBar1.Value = 100 * rmesh / rmeshsum
                If ik > 1 Then
                    Dim timenew As Date = Now
                    sec = TimeLap(Timst, timenew)
                    b1 = rmeshsum - rmesh
                    Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算
                End If
                ikb = ik
                If icc > 0 Then
                    Exit For
                End If
            Next ik

            aa$ = "濃度計算" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

            Application.DoEvents()
            Call ConcAnalysis(mbht)       '濃度解析

            Application.DoEvents()
            zdvel = dvel
            Call ResFile3(ikb, velmax, zdvel)   '計算結果の出力3
            Application.DoEvents()
            Call StressCalc()                   '剪断速度・応力の計算
            Application.DoEvents()
            Call ResFile4()                     '計算結果の出力4

            Application.DoEvents()
            aa$ = "面の流出入量 計算中" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Call FvolumeCalc(1, velmax, zvel1)  '要素辺の流出入量の計算

        Else    '非定常の場合
            itime = 0
            df = 100 / Ntime
            rmeshsum = Ntime     'ﾒｯｼｭ合計
            TimeNew = 0
            Call InitDataSet()  '初期値設定
            Call ConcInitSet()      '初期濃度設定
            Call ResFile3T(0, velmax)   '非定常の結果ﾌｧｲﾙへの出力3
            Dim rdate As Date = Now
            date1 = rdate
            time1 = 0
            date2 = date1
            time2 = 0
            itime = 1
            Dtime = DtimeInit
            dtime0 = Dtime
            dtimestd = TimeMax / Ntime
            TimeNew = Dtime
            timenext = dtimestd
            Kinit = 0

            Do
                Application.DoEvents()
                icc = 0
                aa$ = "時間" + Str(TimeNew)
                aa$ = aa$ + "　No." + Str(ik) + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)

                Call PDiffVelCalcT()    '非定常の速度偏微分の計算

                Application.DoEvents()
                Call MatrixCalcT(mbh, mbht)     'ﾏﾄﾘｯｸｽ計算

                For i = 1 To Neff
                    Voldx(i) = Vold(i)
                    Vold(i) = Tff(i)
                Next i

                aa$ = "濃度計算" + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)

                Application.DoEvents()
                Call ConcAnalysisT(mbht)       '非定常の濃度解析

                Application.DoEvents()
                date0 = date1
                time0 = time1
                date1 = date2
                time1 = time2
                Dim rdate1 As Date = Now
                date2 = rdate1
                time2 = TimeNew
                If TimeNew >= timenext - 0.00001 Then
                    TimeNew = timenext
                    Call ResFile3T(itime, velmax)   '非定常の結果ﾌｧｲﾙへの出力3
                    Application.DoEvents()
                    Call StressCalc()               '剪断速度・応力の計算
                    Application.DoEvents()

                    aa$ = "面の流出入量 計算中" + "   "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    Call FvolumeCalc(1, velmax, zvel1)  '要素辺の流出入量の計算

                    rmesh = itime
                    b1 = time1 - time0
                    If b1 >= Dtime Then
                        sec = TimeLap(date0, date1)
                    Else
                        b1 = Dtime
                        sec = TimeLap(date1, date2)
                    End If
                    Call ReqTimeT(rmesh, rmeshsum, b1, sec)   '残りの所要時間の計算

                    '進行表示
                    Fw1 = Fw1 + df
                    ProgressBar1.Value = 100 * Fw1 / Fw2

                    itime = itime + 1
                    timenext = TimeMax * itime / Ntime
                End If
                If itime > Ntime Then
                    icheck = 1
                End If
                If icheck = 0 Then
                    If dtime0 < dtimestd Then
                        If dtime0 = Dtime Then
                            Call DvelCalc(dvel)        '最大速度変化の計算
                            If dvel <= 0.5 * DvelMax Then
                                dtime0 = 1.5 * Dtime
                            End If
                            If dtime0 > 0.5 * RateMAmax Then
                                dtime0 = 0.5 * RateMAmax
                            End If
                            If dtime0 > dtimestd - 0.00001 Then
                                dtime0 = dtimestd
                            End If
                        End If
                    End If
                    dtime1 = timenext - TimeNew
                    If dtime1 < dtime0 + 0.00001 Then
                        Dtime = dtime1
                    Else
                        Dtime = dtime0
                    End If
                    If Kinit = 0 Then
                        TimeStd = TimeNew
                        For i = 1 To Neff
                            Tff0(i) = Tff(i)
                        Next i
                    End If
                    TimeNew = TimeNew + Dtime
                    For i = 1 To Neff
                        Tffx(i) = Tff(i)
                        Voldx(i) = Tff(i)
                        Vold(i) = Tff(i)
                    Next i
                    For i = 1 To Npoint
                        Tftx(i) = Tft(i)
                    Next i
                    Svelold = 0
                    Kinit = 1
                End If

                aa$ = "ﾙｰﾌﾟ終了" + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
            Loop Until icheck = 1
            Application.DoEvents()
            Call ResFile4T()    '非定常の計算結果の出力4

        End If

        Call ResFile5()                     '計算結果の出力5

        Application.DoEvents()
        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        freemem = Int(FreeMemoryGet() / 1000.0)
        aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
        SwK.WriteLine(aa$)

        If iconv > 0 Or Mstat > 0 Then
            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            If Mstat = 0 Then
                aa$ = aa$ + Cr$ + "繰り返し計算回数" + Str$(ikb)
            Else
                aa$ = aa$ + Cr$ + "最終の計算時間間隔" + Str(Dtime)
            End If
            aa$ = aa$ + Cr$ + CalcRes$
        Else
            aa$ = "計算が収束しませんでした！"
            SwK.WriteLine(aa$)
            aa$ = aa$ + Cr$ + "計算結果をファイルへ出力しました。"
        End If
        SwK.Close()
        Me.BringToFront()
        If KindBatch = 0 Then
            MsgBox(aa$, 0, "計算確認")
        Else
            Kfinish = 1
        End If
        gr.Dispose()
        Me.Close()

    End Sub
End Class
